#include <Windows.h>
#include <stdio.h>
#include <intrin.h>
#include <tchar.h>

#define CPU_CPP 0x01

#include "cpu.h"

TCHAR* ecx1_str[] = {
	TEXT("\ς"),  // 31
	TEXT("RDRAND"),  // 30
	TEXT("16-bit floating-point conversion instructions"),  // 29
	TEXT("AVX"),  // 28
	TEXT("OS-Enabled-Extended State Management"),  // 27
	TEXT("XSAVW/XSTOR States"),  // 26
	TEXT("AESNI߃Zbg"),  // 25
	TEXT("Time Stamp Counter Deadline"),  // 24
	TEXT("POPCNT"),  // 23
	TEXT("MOVBE "),  // 22
	TEXT("x2APIC"),  // 21
	TEXT("Xg[~OSIMDg4.2"),  // 20
	TEXT("Xg[~OSIMDg4.1"),  // 19
	TEXT("Direct Cache Access"),  // 18
	TEXT("Process Context Identifiers"),  // 17
	TEXT("\ς"),  // 16
	TEXT("Perfmon and Debug Capability"),  // 15
	TEXT("xTPR Update Control"),  // 14
	TEXT("CMPXCHG16B"),  // 13
	TEXT("Fused Multiply Add"),  // 12
	TEXT("\ς"),  // 11
	TEXT("L1 ContextID"),  // 10
	TEXT("Xg[~OSIMDg3(SSSE3)"),  // 9
	TEXT("xj^2"),  // 8
	TEXT("gIntel SpeedStep(R)eNmW"),  // 7
	TEXT("Safer Mode Extensions"),  // 6
	TEXT("Virtual Machine Extensions"),  // 5
	TEXT("CPL Qualified Debug Store"),  // 4
	TEXT("MONITOR/MWAIT"),  // 3
	TEXT("64bit Debug Store"),  // 2
	TEXT("PCLMULDQ߃Zbg"),  // 1
	TEXT("Xg[~OSIMDg3") // 0
};

TCHAR* edx1_str[] = {
	TEXT("yfBOu[NCl[u"),  // 31
	TEXT("\ς"),  // 30
	TEXT("xj^"),  // 29
	TEXT("nCp[XbfBOeNmW"),  // 28
	TEXT("ȃXk[v"),  // 27
	TEXT("Xg[~OSIMDg2"),  // 26
	TEXT("Xg[~OSIMDg"),  // 25
	TEXT("FXSAVE/FXRSTOR"),  // 24
	TEXT("MMXeNmW"),  // 23
	TEXT("xj^ƃ\tgEFANbN@\"),  // 22
	TEXT("fobNXgA"),  // 21
	TEXT("\ς"),  // 20
	TEXT("CFLUSH "),  // 19
	TEXT("vZbT̃VAԍ"),  // 18
	TEXT("36rbgy[W TCY̊g@\"),  // 17
	TEXT("x[We[u"),  // 16
	TEXT("tړ"),  // 15
	TEXT("}V`FbNA[LeN`(MCG_CAP)"),  // 14
	TEXT("PDEEPTB̃O[orbg"),  // 13
	TEXT("^Cv͈̓WX^(MTRR_CAP)"),  // 12
	TEXT("SYSENTERSYSEXIT(VXeR[)"),  // 11
	TEXT("\ς"),  // 10
	TEXT("I`bvAPICn[hEFA"),  // 9
	TEXT("CMPXCHG8B"),  // 8
	TEXT("}V`FbNO(O18 CR4.MCEClurbg)"),  // 7
	TEXT("AhXg@\(32bitȏ)"),  // 6
	TEXT("RDMSR߁AWRMSR "),  // 5
	TEXT("^CX^vJE^"),  // 4
	TEXT("y[W TCYg@\"),  // 3
	TEXT("fobNg@\"),  // 2
	TEXT("z8086[hg@\"),  // 1
	TEXT("I`bvFPU")   // 0
};

//code, type, level, way, size(kb), line
CACHE_CODE cache_code[] = {
	{ 0x06, 2, 1, 4, 8, 32 },  // code L1 cache, 8 KB, 4 ways, 32 byte lines
	{ 0x08, 2, 1, 4, 16, 32 },  // code L1 cache, 16 KB, 4 ways, 32 byte lines
	{ 0x09, 2, 1, 4, 32, 64 },  // code L1 cache, 32 KB, 4 ways, 64 byte lines
	{ 0x0A, 1, 1, 2, 8, 32 },  // data L1 cache, 8 KB, 2 ways, 32 byte lines
	{ 0x0C, 1, 1, 4, 16, 32 },  // data L1 cache, 16 KB, 4 ways, 32 byte lines
	{ 0x0D, 1, 1, 4, 16, 64 },  // data L1 cache, 16 KB, 4 ways, 64 byte lines (ECC)
	{ 0x0E, 1, 1, 6, 24, 64 },  // data L1 cache, 24 KB, 6 ways, 64 byte lines
	{ 0x21, 3, 2, 8, 256, 64 },  // code and data L2 cache, 256 KB, 8 ways, 64 byte lines
	{ 0x22, 3, 3, 4, 512, 64 },  // code and data L3 cache, 512 KB, 4 ways (!), 64 byte lines, dual-sectored
	{ 0x23, 3, 3, 8, 1024, 64 },  // code and data L3 cache, 1024 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x25, 3, 3, 8, 2048, 64 },  // code and data L3 cache, 2048 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x29, 3, 3, 8, 4096, 64 },  // code and data L3 cache, 4096 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x2C, 1, 1, 8, 32, 64 },  // data L1 cache, 32 KB, 8 ways, 64 byte lines
	{ 0x30, 2, 1, 8, 32, 64 },  // code L1 cache, 32 KB, 8 ways, 64 byte lines
	{ 0x41, 3, 2, 4, 128, 32 },  // code and data L2 cache, 128 KB, 4 ways, 32 byte lines
	{ 0x42, 3, 2, 4, 256, 32 },  // code and data L2 cache, 256 KB, 4 ways, 32 byte lines
	{ 0x43, 3, 2, 4, 512, 32 },  // code and data L2 cache, 512 KB, 4 ways, 32 byte lines
	{ 0x44, 3, 2, 4, 1024, 32 },  // code and data L2 cache, 1024 KB, 4 ways, 32 byte lines
	{ 0x45, 3, 2, 4, 2048, 32 },  // code and data L2 cache, 2048 KB, 4 ways, 32 byte lines
	{ 0x46, 3, 3, 4, 4096, 64 },  // code and data L3 cache, 4096 KB, 4 ways, 64 byte lines
	{ 0x47, 3, 3, 8, 8192, 64 },  // code and data L3 cache, 8192 KB, 8 ways, 64 byte lines
	{ 0x48, 3, 2, 12, 3072, 64 },  // code and data L2 cache, 3072 KB, 12 ways, 64 byte lines
	{ 0x49, 3, 3, 16, 4096, 64 },  // code and data L3 cache, 4096 KB, 16 ways, 64 byte lines (P4) or
	{ 0x4A, 3, 3, 12, 6144, 64 },  // code and data L3 cache, 6144 KB, 12 ways, 64 byte lines
	{ 0x4B, 3, 3, 16, 8192, 64 },  // code and data L3 cache, 8192 KB, 16 ways, 64 byte lines
	{ 0x4C, 3, 3, 12, 12288, 64 },  // code and data L3 cache, 12288 KB, 12 ways, 64 byte lines
	{ 0x4D, 3, 3, 16, 16384, 64 },  // code and data L3 cache, 16384 KB, 16 ways, 64 byte lines
	{ 0x4E, 3, 2, 24, 6144, 64 },  // code and data L2 cache, 6144 KB, 24 ways, 64 byte lines
	{ 0x60, 1, 1, 8, 16, 64 },  // data L1 cache, 16 KB, 8 ways, 64 byte lines, sectored
	{ 0x66, 1, 1, 4, 8, 64 },  // data L1 cache, 8 KB, 4 ways, 64 byte lines, sectored
	{ 0x67, 1, 1, 4, 16, 64 },  // data L1 cache, 16 KB, 4 ways, 64 byte lines, sectored
	{ 0x68, 1, 1, 4, 32, 64 },  // data L1 cache, 32 KB, 4 ways, 64 byte lines, sectored
	{ 0x78, 3, 2, 4, 1024, 64 },  // code and data L2 cache, 1024 KB, 4 ways, 64 byte lines
	{ 0x79, 3, 2, 8, 128, 64 },  // code and data L2 cache, 128 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x7A, 3, 2, 8, 256, 64 },  // code and data L2 cache, 256 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x7B, 3, 2, 8, 512, 64 },  // code and data L2 cache, 512 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x7C, 3, 2, 8, 1024, 64 },  // code and data L2 cache, 1024 KB, 8 ways, 64 byte lines, dual-sectored
	{ 0x7D, 3, 2, 8, 2048, 64 },  // code and data L2 cache, 2048 KB, 8 ways, 64 byte lines
	{ 0x7F, 3, 2, 2, 512, 64 },  // code and data L2 cache, 512 KB, 2 ways, 64 byte lines
	{ 0x80, 3, 2, 8, 512, 64 },  // code and data L2 cache, 512 KB, 8 ways, 64 byte lines
	{ 0x82, 3, 2, 8, 256, 32 },  // code and data L2 cache, 256 KB, 8 ways, 32 byte lines
	{ 0x83, 3, 2, 8, 512, 32 },  // code and data L2 cache, 512 KB, 8 ways, 32 byte lines
	{ 0x84, 3, 2, 8, 1024, 32 },  // code and data L2 cache, 1024 KB, 8 ways, 32 byte lines
	{ 0x85, 3, 2, 8, 2048, 32 },  // code and data L2 cache, 2048 KB, 8 ways, 32 byte lines
	{ 0x86, 3, 2, 4, 512, 64 },  // code and data L2 cache, 512 KB, 4 ways, 64 byte lines
	{ 0x87, 3, 2, 8, 1024, 64 },  // code and data L2 cache, 1024 KB, 8 ways, 64 byte lines
	{ 0xD0, 3, 3, 4, 512, 64 },  // code and data L3 cache, 512-kb, 4 ways, 64 byte lines
	{ 0xD1, 3, 3, 4, 1024, 64 },  // code and data L3 cache, 1024-kb, 4 ways, 64 byte lines
	{ 0xD2, 3, 3, 4, 2048, 64 },  // code and data L3 cache, 2048-kb, 4 ways, 64 byte lines
	{ 0xD6, 3, 3, 8, 1024, 64 },  // code and data L3 cache, 1024-kb, 8 ways, 64 byte lines
	{ 0xD7, 3, 3, 8, 2048, 64 },  // code and data L3 cache, 2048-kb, 8 ways, 64 byte lines
	{ 0xD8, 3, 3, 8, 4096, 64 },  // code and data L3 cache, 4096-kb, 8 ways, 64 byte lines
	{ 0xDC, 3, 3, 12, 1536, 64 },  // code and data L3 cache, 1536-kb, 12 ways, 64 byte lines
	{ 0xDD, 3, 3, 12, 3072, 64 },  // code and data L3 cache, 3072-kb, 12 ways, 64 byte lines
	{ 0xDE, 3, 3, 12, 6144, 64 },  // code and data L3 cache, 6144-kb, 12 ways, 64 byte lines
	{ 0xE2, 3, 3, 16, 2048, 64 },  // code and data L3 cache, 2048-kb, 16 ways, 64 byte lines
	{ 0xE3, 3, 3, 16, 4096, 64 },  // code and data L3 cache, 4096-kb, 16 ways, 64 byte lines
	{ 0xE4, 3, 3, 16, 8192, 64 },  // code and data L3 cache, 8192-kb, 16 ways, 64 byte lines
	{ 0xEA, 3, 3, 24, 12288, 64 },  // code and data L3 cache, 12288-kb, 24 ways, 64 byte lines
	{ 0xEB, 3, 3, 24, 18432, 64 },  // code and data L3 cache, 18432-kb, 24 ways, 64 byte lines
	{ 0xEC, 3, 3, 24, 24576, 64 },  // code and data L3 cache, 24576-kb, 24 ways, 64 byte lines
	{ 0x70, 4, 1, 8, 12, 1 },  // trace L1 cache, 12 KOPs, 8 ways
	{ 0x71, 4, 1, 8, 16, 1 },  // trace L1 cache, 16 KOPs, 8 ways
	{ 0x72, 4, 1, 8, 32, 1 },  // trace L1 cache, 32 KOPs, 8 ways
	{ 0x40, 0, 0, 0, 0, 0 },  // no integrated L2 cache (P6 core) or L3 cache (P4 core)
	{ 0x00, 0, 0, 0, 0, 0 } };

TCHAR* cache_type_str(int n){
	TCHAR* p = 0;
	switch (n){
	case 0:	p = _TEXT("null");	break;
	case 1:	p = _TEXT("Data Cache");	break;
	case 2:	p = _TEXT("Instruction Cache");	break;
	case 3:	p = _TEXT("Unified Cache");	break;
	case 4: p = _TEXT("Trace Cache"); break;
	default:	p = _TEXT("null");	break;
	}
	return p;
}

TCHAR* ebx7_str[] = {
	_TEXT("AVX512VL"),  // 31
	_TEXT("AVX512BW"),  // 30
	_TEXT("SHA"),  // 29
	_TEXT("AVX512CD"),  // 28
	_TEXT("AVX512ER"),  // 27
	_TEXT("AVX512PF"),  // 26
	_TEXT("Intel Processor Trace"),  // 25
	_TEXT("Reserved"),  // 24
	_TEXT("CLFLUSHOPT"),  // 23
	_TEXT("Reserved"),  // 22
	_TEXT("AVX512IFMA52"),  // 21
	_TEXT("Supervisor Mode Access Prevention"),  // 20
	_TEXT("The ADCX and ADOX instructions"),  // 19
	_TEXT("RDSEED instructions"),  // 18
	_TEXT("AVX512DQ"),  // 17
	_TEXT("AVX512F"),  // 16
	_TEXT("Platform Quality of Service Enforcement (PQE)"),  // 15
	_TEXT("Intel Memory Protection Extensions"),  // 14
	_TEXT("Deprecates FPU CS and FPU DS"),  // 13
	_TEXT("Platform Quality of Service Monitoring (PQM)"),  // 12
	_TEXT("RTM Restricted Transactional Memory"),  // 11
	_TEXT("Processor Context ID "),  // 10
	_TEXT("Enhanced REP MOVSB/STOSB"),  // 09
	_TEXT("2nd group bit manipulation extensions"),  // 08
	_TEXT("Supervisor-Mode Execution Prevention"),  // 07
	_TEXT("Reserved"),  // 06
	_TEXT("AVX2  instructions"),  // 05
	_TEXT("Hardware Lock Elision"),  // 04
	_TEXT("1st group bit manipulation extensions"),  // 03
	_TEXT("Reserved"),  // 02
	_TEXT("IA32_TSC_ADJUST MSR."),  // 01
	_TEXT("RDFSBASE/RDGSBASE/WRFSBASE/WRGSBASE")  // 00
};

TCHAR* ecx7_str[] = {
	_TEXT("Reserved"),  // 31
_TEXT("Reserved"),  // 30
_TEXT("Reserved"),  // 29
_TEXT("Reserved"),  // 28
_TEXT("Reserved"),  // 27
_TEXT("Reserved"),  // 26
_TEXT("Reserved"),  // 25
_TEXT("Reserved"),  // 24
_TEXT("Reserved"),  // 23
_TEXT("Reserved"),  // 22
_TEXT("Reserved"),  // 21
_TEXT("Reserved"),  // 20
_TEXT("Reserved"),  // 19
_TEXT("Reserved"),  // 18
_TEXT("Reserved"),  // 17
_TEXT("Reserved"),  // 16
_TEXT("Reserved"),  // 15
_TEXT("Reserved"),  // 14
_TEXT("Reserved"),  // 13
_TEXT("Reserved"),  // 12
_TEXT("Reserved"),  // 11
_TEXT("Reserved"),  // 10
_TEXT("Reserved"),  // 09
_TEXT("Reserved"),  // 08
_TEXT("Reserved"),  // 07
_TEXT("Reserved"),  // 06
_TEXT("Reserved"),  // 05
_TEXT("Reserved"),  // 04
_TEXT("Reserved"),  // 03
_TEXT("Reserved"),  // 02
_TEXT("AVX512VBMI"),  // 01
_TEXT("PREFETCHWT1")  // 00
};

TCHAR* ebx10_str[]={
_TEXT("Reserved"),  // 31
_TEXT("Reserved"),  // 30
_TEXT("Reserved"),  // 29
_TEXT("Reserved"),  // 28
_TEXT("Reserved"),  // 27
_TEXT("Reserved"),  // 26
_TEXT("Reserved"),  // 25
_TEXT("Reserved"),  // 24
_TEXT("Reserved"),  // 23
_TEXT("Reserved"),  // 22
_TEXT("Reserved"),  // 21
_TEXT("Reserved"),  // 20
_TEXT("Reserved"),  // 19
_TEXT("Reserved"),  // 18
_TEXT("Reserved"),  // 17
_TEXT("Reserved"),  // 16
_TEXT("Reserved"),  // 15
_TEXT("Reserved"),  // 14
_TEXT("Reserved"),  // 13
_TEXT("Reserved"),  // 12
_TEXT("Reserved"),  // 11
_TEXT("Reserved"),  // 10
_TEXT("Reserved"),  // 09
_TEXT("Reserved"),  // 08
_TEXT("Reserved"),  // 07
_TEXT("branch mispredicts retired event unavailable"),  // 06
_TEXT("branch instructions retired event unavailable"),  // 05
_TEXT("last level cache misses event unavailable"),  // 04
_TEXT("last level cache references event unavailable"),  // 03
_TEXT("reference cycles event unavailable"),  // 02
_TEXT("instructions retired event unavailable"),  // 01
_TEXT("core cycles event unavailable")  // 00
};

TCHAR* ecx11_level_str[] = { _TEXT("invalid"),_TEXT("SMT"), _TEXT("Core"), 0 };

EXT_INST ext_inst[] = {
	{ 0x00000001, 3, 23, _TEXT("MMX") },
	{ 0x00000001, 3, 25, _TEXT("SSE") },
	{ 0x00000001, 3, 26, _TEXT("SSE2") },
	{ 0x00000001, 2, 0, _TEXT("SSE3") },
	{ 0x00000001, 2, 9, _TEXT("SSSE3") },
	{ 0x00000001, 2, 19, _TEXT("SSE4.1") },
	{ 0x00000001, 2, 20, _TEXT("SSE4.2") },
	{ 0x00000001, 2, 28, _TEXT("AVX") },
	{ 0x00000007, 1, 5, _TEXT("AVX2") },
	{ 0x00000001, 2, 25, _TEXT("AESNI") },
	{ 0x00000001, 2, 12, _TEXT("FMA") },
	{ 0x00000007, 1, 19, _TEXT("ADCX & ADOX") },
	{ 0x00000007, 1, 14, _TEXT("MPX") },
	{ 0x80000001, 3, 29, _TEXT("EM64T") },
	{ 0x00000006, 0, 1, _TEXT("Turbo Boost") },
	{ 0x00000001, 2, 5, _TEXT("VT-X") },
	{ 0x80000001, 3, 20, _TEXT("NX/XD-bit") },
	{ 0x00000000, 0,  0, 0 },
};


void REG32::put_listview(HWND hList, int num){
	TCHAR buf[64];
	LV_ITEM item;
	item.mask = LVIF_TEXT;
	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), eax);
	item.pszText = buf;
	item.iItem = num;
	item.iSubItem = 2;
	ListView_SetItem(hList, &item);

	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), ebx);
	item.iSubItem = 3;
	ListView_SetItem(hList, &item);

	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), ecx);
	item.iSubItem = 4;
	ListView_SetItem(hList, &item);

	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), edx);
	item.iSubItem = 5;
	ListView_SetItem(hList, &item);
}


void CPU_PKG::DrawOwn(HDC hdc, int sx, int sy, int cpuNum){	// 1̕CPU
	Rectangle(hdc, sx, sy, sx + cx, sy + cy);
	TCHAR buf[128];

	int smt = threadMax / coreMax;
	for (int n = 0; n < smt; n++){
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%i"), threadvec[smt*cpuNum + n]);
		TextOut(hdc, sx + 4 + n * 20, sy + 4, buf, (int)_tcslen(buf));
	}
}

void CPU_PKG::Draw(HDC hdc, int sx, int sy, int* ex, int* ey){
	HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;

	hPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	hOldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateHatchBrush(HS_CROSS, RGB(0, 255, 0));
	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);

	if (coreMax <= 6){
		for (DWORD n = 0; n < coreMax; n++){
			DrawOwn(hdc, sx + px, sy + py + n*cy, n);
		}
		*ex = sx + px * 2 + cx;
		*ey = sy + py * 2 + coreMax*cy;
	}
	else if (coreMax <= 8){
		DWORD n;
		for (n = 0; n < 4; n++){
			DrawOwn(hdc, sx + px, sy + py + n*cy, n);
		}
		n = -4;
		for (n = 0; n < coreMax - 4; n++){
			DrawOwn(hdc, sx + px + cx, sy + py + n*cy, n);
		}
		*ex = sx + px * 2 + cx * 2;
		*ey = sy + py * 2 + cy * 4;
	}
	else{
		DWORD n;
		int x = 0;
		int y = 0;
		for (n = 0; n < coreMax; n++){
			DrawOwn(hdc, sx + px + x*cx, sy + py + y*cy, n);
			if (++y == 5){
				y = 0;
				++x;
			}
		}
		*ex = sx + px * 2 + (x + 1)*cx;
		*ey = sy + py * 2 + (5)*cy;
	}

	SelectObject(hdc, GetStockObject(NULL_BRUSH));
	Rectangle(hdc, sx, sy, *ex, *ey);

	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	DeleteObject(hPen);
}

CPU::CPU(){
	cpu_pkg = 0;
	smt = core = pkg = 0;
	temp = 0;
	emu_cpu_num = 0;
}
CPU::CPU(int package){	//	G~[V\Pbgw
	pkgMax = package;
	cpu_pkg = new CPU_PKG_P[pkgMax];
	for (DWORD n = 0; n < pkgMax; n++){
		cpu_pkg[n] = new CPU_PKG;
	}
	smt = core = pkg = 0;
	temp = 0;
	emu_cpu_num = 0;
}

CPU::~CPU(){
	delete[] smt;
	delete[] core;
	delete[] pkg;
	delete[] temp;
}
void CPU::Draw(HDC hdc, int sx, int sy){
	int ex, ey;
	DWORD n;
	TCHAR buf[128];

	for (n = 0; n < pkgMax; n++){
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("\Pbg%i"), n);
		TextOut(hdc, sx, sy, buf, (int)_tcslen(buf));
		cpu_pkg[n]->Draw(hdc, sx, sy + cpu_pkg[n]->py, &ex, &ey);
		sx = ex + cpu_pkg[n]->px;
	}
}

int CPU::getPackageMax(void){	//	pbP[W(\Pbg)擾
	return pkgMax;
}

void CPU::parse(void){
	int cMax = 0;
	DWORD n;

	DEBUG_MSG_STR("CPU::parse()   Jn܂");

	for (n = 0; n < lCpuMax; n++){
		CMP_TEMP t;
		t.pkg = (unsigned char)pkg[n];
		t.core = (unsigned char)core[n];
		t.smt = (unsigned char)smt[n];
		t.num = (unsigned char)n;
		temp[n] = t.dword;

	}
	qsort(temp, lCpuMax, sizeof(temp[0]), dwordcmp);

	int coreCount = 0;
	int smtCount = 0;
	int pkgCount = 0;

	int rePkg = 0;
	int reCore = -1;
	int reSmt = -1;
	int threadCount = 0;
	CMP_TEMP t = *((CMP_TEMP*)(&temp[lCpuMax - 1]));
	if (cpu_pkg == 0){
		pkgMax = t.pkg+1;
		cpu_pkg = new CPU_PKG_P[pkgMax];
		for (n = 0; n < pkgMax; n++)
			cpu_pkg[n] = new CPU_PKG;
	}
	for (n = 0; n < lCpuMax; n++){
		t.dword = temp[n];
		if (rePkg != t.pkg){
			cpu_pkg[pkgCount]->coreMax = coreCount;
			cpu_pkg[pkgCount]->threadMax = threadCount;
			threadCount = 0;
			++pkgCount;
			coreCount = 0;
			smtCount = 0;
			rePkg = -1;
			reCore = -1;
		}
		if (reSmt != t.smt)
			++smtCount;
		if (reCore != t.core)
			++coreCount;
		++threadCount;
		rePkg = t.pkg;
		reCore = t.core;
		reSmt = t.smt;
	}
	cpu_pkg[pkgCount]->coreMax = coreCount;
	cpu_pkg[pkgCount]->threadMax = threadCount;

	DEBUG_MSG_INI(_TEXT("CPU::parse()   pbP[W"), pkgMax);
	DEBUG_MSG_INI(_TEXT("CPU::parse()   RA"), coreCount);
	DEBUG_MSG_INI(_TEXT("CPU::parse()   Xbh"), threadCount);

	for (n = 0; n < pkgMax; n++){
		int num = cpu_pkg[n]->threadMax;
		cpu_pkg[n]->threadvec = new int[cpu_pkg[n]->threadMax];
		cpu_pkg[n]->corevec = new int[cpu_pkg[n]->threadMax];
	}
	int u = 0;
	rePkg = 0;
	for (n = 0; n < lCpuMax; n++){
		CMP_TEMP t;
		t.dword = temp[n];
		if (rePkg != t.pkg){
			u = 0;
		}
		cpu_pkg[t.pkg]->threadvec[u] = t.num;
		cpu_pkg[t.pkg]->corevec[u] = t.core;
		++u;
		rePkg = t.pkg;
	}
#if 0
	for (n = 0; n < lCpuMax; n++){
		CMP_TEMP t;
		t.dword = temp[n];
	}
#endif
}
int dwordcmp(const void *dtcp, const void* srcp){
	int dtc = *(int*)dtcp;
	int src = *(int*)srcp;
	return dtc - src;

}
void CPU::get(void){
	DEBUG_MSG_STR("CPU::get()Jn܂");
	SYSTEM_INFO sys;
	::GetSystemInfo(&sys);
	lCpuMax = sys.dwNumberOfProcessors;	//݂̃VXe̘_CPU

	smt = new DWORD[lCpuMax];
	core = new DWORD[lCpuMax];
	pkg = new DWORD[lCpuMax];
	temp = new DWORD[lCpuMax];

	CPU_PKG cpu_pkg_temp;

	HANDLE h;
	h = GetCurrentThread();
	for (DWORD n = 0; n < lCpuMax; n++){
#ifdef CPU_EMU
		cpunum = n;
#else
		DEBUG_MSG_INI(_TEXT("CPU::get() SetThreadAffinityMask Jn܂"),n);
		SetThreadAffinityMask(h, 1 << n);	//	CPU0ɌŒ
#endif
		Sleep(1);
		TCHAR cpuname[48];
		GetCpuName(cpuname);
		DWORD CorePlus_Mask_Width,  SMT_Mask_Width;
		DEBUG_MSG_INI(_TEXT("CPU::get()  cpu_pkg_temp.getTopologyBit Jn܂"), n);
		DWORD apic = cpu_pkg_temp.getTopologyBit(&CorePlus_Mask_Width, &SMT_Mask_Width);
		DEBUG_MSG_INI(_TEXT("CPU::get() CorePlus_Mask_Width  Jn܂"), CorePlus_Mask_Width);
		cpu_pkg_temp.GetTopology(apic, &pkg[n], &core[n], &smt[n], CorePlus_Mask_Width, SMT_Mask_Width);
	}
	parse();
}

static void GetCpuName(TCHAR* cpuname){
	REG32 reg[3];
	__cpuid(reg[0].vec, 0x80000000);
	if (0x80000002 <= reg[0].eax){	//	vZbTuh̎擾\ł
		__cpuid(reg[0].vec, 0x80000002);
		__cpuid(reg[1].vec, 0x80000003);
		__cpuid(reg[2].vec, 0x80000004);
		char* p = (char*)&reg;
		for (int n = 0; n < 4 * 4 * 3; n++){
			cpuname[n] = *p++;
		}
	}
	else
		cpuname[0] = 0;
}

//	Kvbit擾

int bit_count(DWORD d){
	//	dɕKvbitZ肷
	int bit = 0;
	DWORD mask = 1;
	for (int b = 0; b<32; b++){
		if (mask >= d){
			bit = b;
			break;
		}
		mask = mask << 1;
	}
	return bit;
}

void CPU_PKG::cpuid_cpp_put(FILE* fp,TCHAR* fname){	//	pbP[WCPUIDNXăt@Cɏo
	DWORD n;
	TCHAR cname[64];
	_stprintf_s(cname, sizeof(cname) / sizeof(cname[0]), _TEXT("%s"), fname);
	_tcsupr_s(cname, 64);
	TCHAR* p = cname;
	while (*p){
		if (*p == _T('-'))
			*p = _T('_');
		++p;
	}
	_ftprintf(fp, _TEXT("#ifndef CPU_EMU\n"));
	_ftprintf(fp, _TEXT("\t#define CPU_EMU \"%s\"\n\n"), name);
	_ftprintf(fp, _TEXT("#endif\n"));
	_ftprintf(fp, _TEXT("struct %s_CPU : public CPU_PKG{ // %s\n"), cname, name);
	_ftprintf(fp,
		_TEXT("\t%s_CPU() : CPU_PKG(){\n")
		_TEXT("\t\tDWORD n;\n")
		_TEXT("\t\tcoreMax = %i;\n")
		_TEXT("\t\tthreadMax = %i;\n"), cname, coreMax, threadMax);

	_ftprintf(fp, _TEXT("\t\tstatic REG32 r[] = {\n"));
	for (n = 0; n < cpuid_max; n++){
		_ftprintf(fp, _TEXT("\t\t\t{ "));
		cpuid_tbl[n].put(fp);
		_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
	}
	_ftprintf(fp,
		_TEXT("\t\t};\n")
		_TEXT("\t\tcpuid_tbl = r;\n")
		_TEXT("\t\tcpuid_max = sizeof(r) / sizeof(REG32);\n\n"));

	_ftprintf(fp, _TEXT("\t\tstatic DWORD a[] = {\n\t\t\t"));
	for (n = 0; n < threadMax; n++){
		if (n)
			_ftprintf(fp, _TEXT(","));
		_ftprintf(fp, _TEXT("%d"), apic[n]);
	}
	_ftprintf(fp, _TEXT("\n\t\t};\n\n"));


	_ftprintf(fp, _TEXT("\t\tstatic REG32 r2[] = {\n"));
	for (n = 0; n < cpuid2_max; n++){
		_ftprintf(fp, _TEXT("\t\t\t{ "));
		cpuid2_tbl[n].put(fp);
		_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
	}
	_ftprintf(fp,
		_TEXT("\t\t};\n")
		_TEXT("\t\tcpuid2_tbl = r2;\n")
		_TEXT("\t\tcpuid2_max = sizeof(r2) / sizeof(REG32);\n\n"));

	_ftprintf(fp, _TEXT("\t\tstatic REG32 r4[] = {\n"));
	for (n = 0; n < cpuid4_max; n++){
		_ftprintf(fp, _TEXT("\t\t\t{ "));
		cpuid4_tbl[n].put(fp);
		_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
	}
	_ftprintf(fp,
		_TEXT("\t\t};\n")
		_TEXT("\t\tcpuid4_tbl = r4;\n")
		_TEXT("\t\tcpuid4_max = sizeof(r4) / sizeof(REG32);\n\n"));

	if (7 < cpuid_max){
		_ftprintf(fp, _TEXT("\t\tstatic REG32 r7[] = {\n"));
		for (n = 0; n < cpuid7_max; n++){
			_ftprintf(fp, _TEXT("\t\t\t{ "));
			cpuid7_tbl[n].put(fp);
			_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
		}
		_ftprintf(fp,
			_TEXT("\t\t};\n")
			_TEXT("\t\tcpuid7_tbl = r7;\n")
			_TEXT("\t\tcpuid7_max = sizeof(r7) / sizeof(REG32);\n\n"));
	}

	if (11 < cpuid_max){
		_ftprintf(fp, _TEXT("\t\tstatic REG32 r11[] = {\n"));
		for (n = 0; n < cpuid11_max; n++){
			_ftprintf(fp, _TEXT("\t\t\t{ "));
			cpuid11_tbl[n].put(fp);
			_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
		}
		_ftprintf(fp,
			_TEXT("\t\t};\n")
			_TEXT("\t\tcpuid11_tbl = r11;\n")
			_TEXT("\t\tcpuid11_max = sizeof(r11) / sizeof(REG32);\n\n"));

		_ftprintf(fp, _TEXT("\t\tstatic DWORD x[] = { "));
		for (n = 0; n < threadMax; n++){
			if (n)
				_ftprintf(fp, _TEXT(","));
			_ftprintf(fp, _TEXT("%d"), x2apic[n]);
		}
		_ftprintf(fp, _TEXT("\n\t\t};\n"));
		_ftprintf(fp,
			_TEXT("\t\tx2apic = new DWORD[threadMax];\n")
			_TEXT("\t\tfor (n = 0; n < threadMax; n++){\n")
			_TEXT("\t\t\tx2apic[n] = x[n];\n")
			_TEXT("\t\t}\n\n"));
	}
	if (13 < cpuid_max){
		_ftprintf(fp, _TEXT("\t\tstatic REG32 r13[] = {\n"));
		for (n = 0; n < cpuid13_max; n++){
			_ftprintf(fp, _TEXT("\t\t\t{ "));
			cpuid13_tbl[n].put(fp);
			_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
		}
		_ftprintf(fp,
			_TEXT("\t\t};\n")
			_TEXT("\t\tcpuid13_tbl = r13;\n")
			_TEXT("\t\tcpuid13_max = sizeof(r13) / sizeof(REG32);\n"));

	}

	_ftprintf(fp, _TEXT("\t\tstatic REG32 r8[] = {\n"));
	for (n = 0; n < cpuid80000000_max; n++){
		_ftprintf(fp, _TEXT("\t\t\t{ "));
		cpuid80000000_tbl[n].put(fp);
		_ftprintf(fp, _TEXT(" }, // 0x%0.8x\n"), n);
	}
	_ftprintf(fp,
		_TEXT("\t\t};\n")
		_TEXT("\t\tcpuid80000000_tbl = r8;\n")
		_TEXT("\t\tcpuid80000000_max = sizeof(r8) / sizeof(REG32);\n\n"));

	_ftprintf(fp,
		_TEXT("\t\tapic = new DWORD[threadMax];\n")
		_TEXT("\t\tthreadvec = new int[threadMax];\n")
		_TEXT("\t\tcorevec = new int[threadMax];\n")
		_TEXT("\t\tfor (n = 0; n < threadMax; n++){\n")
		_TEXT("\t\t\tapic[n] = a[n];\n")
		_TEXT("\t\t}\n")
		_TEXT("\t\tcpunameA = (char*)&r8[2];\n")
		_TEXT("\t\tfor (n = 0; n < 48; n++)\n")
		_TEXT("\t\t\tname[n] = cpunameA[n];\n")
		_TEXT("\t\tcache_set();\n")
		_TEXT("\t}\n"));
	_ftprintf(fp,
		_TEXT("\t~%s_CPU(){\n")
		_TEXT("\t\tdelete []apic;\n")
		_TEXT("\t\tdelete []threadvec;\n")
		_TEXT("\t\tdelete []corevec;\n"), cname);
	if (11 < cpuid_max)
		_ftprintf(fp, _TEXT("\t\tdelete []x2apic;\n"));

	_ftprintf(fp, _TEXT("\t}\n};\n\n"));
	_ftprintf(fp, _TEXT("#ifndef CPU_EMU_MULTI\n"));
	_ftprintf(fp, _TEXT("\ttypedef %s_CPU CPU_EMU_CLASS;\n"), cname);
	_ftprintf(fp, _TEXT("#endif\n"));
}


void CPU_PKG::cache_set(void){	// cpuid2cpuid4ɂLbVݒ
	DWORD tlb_max = cpuid2_tbl[0].eax & 0xff;
	DWORD n, t;
	cache_max = 0;
	for (n = 1; n <= tlb_max; n++){
		CACHE_CODE* p;
		DWORD c;
		if ((cpuid2_tbl[n - 1].eax & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].eax >> 24) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].eax >> 16) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].eax >> 8) & 0xff;
			cpuid2_cache_set(c);
			p = cpuid2_cache_find(c);
		}
		if ((cpuid2_tbl[n - 1].ebx & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].ebx >> 24) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].ebx >> 16) & 0xff;
			cpuid2_cache_set(c);
			p = cpuid2_cache_find(c);
			c = (cpuid2_tbl[n - 1].ebx >> 8) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].ebx) & 0xff;
			cpuid2_cache_set(c);
			p = cpuid2_cache_find(c);
		}
		if ((cpuid2_tbl[n - 1].ecx & 0x80000000) == 0){

			c = (cpuid2_tbl[n - 1].ecx >> 24) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].ecx >> 16) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].ecx >> 8) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].ecx) & 0xff;
			cpuid2_cache_set(c);
		}
		if ((cpuid2_tbl[n - 1].edx & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].edx >> 24) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].edx >> 16) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].edx >> 8) & 0xff;
			cpuid2_cache_set(c);
			c = (cpuid2_tbl[n - 1].edx) & 0xff;
			cpuid2_cache_set(c);
		}
	}
	DWORD u;
	DWORD* cacheID = new DWORD[threadMax];
	for (n = 0; n < cpuid4_max; n++){
		EAX4& eax4 = *(EAX4*)&cpuid4_tbl[n].eax;
		EBX4& ebx4 = *(EBX4*)&cpuid4_tbl[n].ebx;
		if ((cpuid4_tbl[n].eax & 0xf) == 0)
			break;
		int nNumberSets = cpuid4_tbl[n].ecx;
		DWORD sz = (ebx4.nWaysAssociativity + 1)*(ebx4.nPhysicalLinePartitions + 1) * (ebx4.nSysLineSize + 1)*(nNumberSets + 1);
		t = cache_max;
		for (u = 0; u < cache_max; u++){
			if (cache[u].level == eax4.nCacheLevel && cache[u].type == eax4.nCacheType){
				t = u;
				break;
			}
		}
		cache[t].type = eax4.nCacheType;
		cache[t].level = eax4.nCacheLevel;
		cache[t].way = ebx4.nWaysAssociativity + 1;
		cache[t].size = sz / 1024;
		cache[t].line = ebx4.nSysLineSize + 1;
		cache[t].code = 0xff;
		cache[t].thread = eax4.nMaxThread + 1;
		DWORD bit_width = bit_count(cache[t].thread);
		cache[t].id_bit_mask = ~(0xffffffff << bit_width);
		if (emuIsX2apic()==true)
			cache[t].apics = x2apic;
		else
			cache[t].apics = apic;
		DWORD max = 0;
		for (u = 0; u < threadMax; u++){
			DWORD c, i;
			bool f = false;
			c = cache[t].apics[u] & cache[t].id_bit_mask;
			for (i = 0; i < max; i++){
				if (cacheID[i] == c){
					f = true;
					break;
				}
			}
			if (f == false){
				cacheID[max++] = c;
			}
		}
		cache[t].uThread = (WORD)max;
		if (t == cache_max)
			cache_max++;
	}
	delete[] cacheID;

	for (n = 0; n < cache_max; n++){
		if (cache[n].type == 4){
			cache[n].uThread = WORD(threadMax / coreMax);
		}
	}
	qsort(cache, cache_max, sizeof(cache[0]), cacheCmp);
}



void CPU::cpuid_cpp_put(void){
	DWORD n;
	DWORD reax1=0;
	TCHAR* rname = _TEXT("");

	for (n = 0; n < pkgMax; n++){
		if (cpu_pkg[n]->cpuid_tbl[1].eax != reax1 || _tcscmp(cpu_pkg[n]->name, rname)){
			TCHAR name[48];
			TCHAR fname[64];
			TCHAR buf[64];

			_tcscpy_s(name, sizeof(name) / sizeof(name[0]), cpu_pkg[n]->name);
			shortCpuName(fname, sizeof(fname) / sizeof(fname[0]), name);

			FILE* fp;
			_stprintf_s(buf, sizeof(buf) / sizeof(buf[0]), _TEXT("cpuid\\%s_emu.h"), fname);
			_tfopen_s(&fp, buf, _TEXT("w,ccs=UNICODE"));

			cpu_pkg[n]->cpuid_cpp_put(fp, fname);

			fclose(fp);
		}
		rname = cpu_pkg[n]->name;
		reax1 = cpu_pkg[n]->cpuid_tbl[1].eax;
	}
}

void shortCpuName(TCHAR* dtc, int sz, TCHAR* cpuname){
	TCHAR* t[16];
	DWORD max = 0;
	TCHAR* p = cpuname;
	DWORD n;
	while (*p){	//	擪̋󔒂ǂ݂Ƃ΂
		if (*p != _T(' '))
			break;
		++p;
	}

	TCHAR* top = p;
	t[0] = p;
	max = 1;
	int re = 0;
	while (*p){	//	󔒂ŋ؂
		if (*p != _T(' ') && re == _T(' ')){
			t[max++] = p;
		}
		re = *p;
		if (*p == _T(' '))
			*p = _T('\0');
		++p;
	}
	DWORD cpu_pos = -1;
	DWORD at_pos = -1;
	DWORD clk_pos = -1;

	for (n = 0; n < max; n++){
		if (_tcsstr(t[n], _TEXT("CPU")))
			cpu_pos = n;
		else if (_tcsstr(t[n], _TEXT("@")))
			at_pos = n;
		else if (_tcsstr(t[n], _TEXT("Hz")))
			clk_pos = n;
	}

	TCHAR shortname2[32];
	TCHAR clks[32];
	TCHAR* n1 = t[1];
	shortname2[0] = 0;
	if (cpu_pos + 1 == clk_pos){	//	Intel(R) Pentium(R) 4 CPU 3.40GHzȂ@ꍇ
		for (n = 2; n < cpu_pos; n++){
			_tcscat_s(shortname2, sizeof(shortname2) / sizeof(TCHAR), t[n]);
			_tcscat_s(shortname2, sizeof(shortname2) / sizeof(TCHAR), _TEXT("_"));
		}
	}
	else{
		for (n = 2; n < at_pos; n++){
			if (cpu_pos != n){
				_tcscat_s(shortname2, sizeof(shortname2) / sizeof(TCHAR), t[n]);
				_tcscat_s(shortname2, sizeof(shortname2) / sizeof(TCHAR), _TEXT("_"));
			}
		}
	}
	int len = (int)_tcslen(n1);
	if ((p = _tcsstr(n1, _TEXT("(TM)")))){
		if (len - 4 == (p - n1)){
			*p = 0;
		}
		else{
			_tcscpy_s(p, 16, p + 4);
		}
	}
	len = (int)_tcslen(n1);
	if ((p = _tcsstr(n1, _TEXT("(R)")))){
		if (len - 3 == (p - n1)){
			*p = 0;
		}
		else{
			_tcscpy_s(p, 16, p + 3);
		}
	}

	DWORD clkv;
	if ((p = _tcsstr(t[clk_pos], _TEXT("G")))){
		*p = 0;
		double c = _tcstod(t[clk_pos], 0);
		clkv = DWORD(c * 1000);
	}
	else{
		p = _tcsstr(t[clk_pos], _TEXT("Hz"));
		*p = 0;
		clkv = _ttoi(t[clk_pos]);
	}
	_stprintf_s(clks, 8, _TEXT("%dMHz"), clkv);
	_stprintf_s(dtc, sz, _TEXT("%s_%s%s"), n1, shortname2, clks);
}

void CPU_PKG::cache_put(FILE* fp){	//	LbV̏o
	DWORD n,u;
	_ftprintf(fp, _TEXT("    LbV\\n"));

	for (n = 0; n < cache_max; n++){
		if (cache[n].code){
			if (cache[n].code == 0x40)
				continue;
			if (cache[n].type != 4){
				_ftprintf(fp, _TEXT("\t%-18s L%d %2dway %dkb line size %d / %d thread\n"), cache_type_str(cache[n].type), cache[n].level, cache[n].way, cache[n].size, cache[n].line, cache[n].uThread);
				_ftprintf(fp, _TEXT("\t  Thread\t  "));
				for (u = 0; u < threadMax; u++){
					_ftprintf(fp, _TEXT(" %2d"), u);
				}
				_ftprintf(fp, _TEXT("\n"));
				_ftprintf(fp, _TEXT("\t  Cache ID\t  "));
				for (u = 0; u < threadMax; u++){
					_ftprintf(fp, _TEXT(" %2d"), cache[n].apics[u] & cache[n].id_bit_mask);
				}
				_ftprintf(fp, _TEXT("\n"));
			}
			else
				_ftprintf(fp, _TEXT("\t   Trace Cache\tL%d %2dway %dkOPs / %d thread\n"), cache[n].level, cache[n].way, cache[n].size, cache[n].uThread);
		}
	}
}

void CPU_PKG::cpuid1_info_put(FILE* fp){
	int n;
	DWORD x, b;

	_ftprintf(fp, _TEXT("    CPUID in EAX=0x00000001\n"));
	EAX1& eax1 = *(EAX1*)&cpuid_tbl[1].eax;
	EBX1& ebx1 = *(EBX1*)&cpuid_tbl[1].ebx;
	ECX1& ecx1 = *(ECX1*)&cpuid_tbl[1].ecx;
	EDX1& edx1 = *(EDX1*)&cpuid_tbl[1].edx;
	int ext_f;
	int ext_m;
	if (eax1.family != 0xf)
		ext_f = eax1.family;
	else
		ext_f = eax1.family + eax1.ex_family;
	if (eax1.family == 6 || eax1.family == 0xf)
		ext_m = (eax1.ex_model << 4) + eax1.model;
	else
		ext_m = eax1.model;
	_ftprintf(fp, _TEXT("\tEAX\n"));
	_ftprintf(fp, _TEXT("\t\tFamily %x,Model %x,Stepping %x\n"), eax1.family, eax1.model, eax1.stepping);
	_ftprintf(fp, _TEXT("\t\tExt Family %0.2x,Ext Model %0.2x\n"), ext_f, ext_m);
	_ftprintf(fp, _TEXT("\tAPIC\t0x%0.2x\n"), ebx1.apic_id);
	_ftprintf(fp, _TEXT("\tuhindex\t0x%0.2x\n"), ebx1.brand_index);
	_ftprintf(fp, _TEXT("\tCTCY %d\n"), ebx1.line_size * 8);
	_ftprintf(fp, _TEXT("\t_vZbT\t%d\n"), ebx1.processer);
	_ftprintf(fp, _TEXT("\tECX\t0x%0.8x\n"), cpuid_tbl[1].ecx);
	x = cpuid_tbl[1].ecx;
	for (n = 31; 0 <= n; n--){
		b = x & 0x80000000;
		if (b){
			_ftprintf(fp, _TEXT("\t\t%0.2d:%s\n"), n, ecx1_str[31 - n]);
		}
		x = x << 1;
	}

	_ftprintf(fp, _TEXT("\tEDX\t0x%0.8x\n"), cpuid_tbl[1].edx);
	x = cpuid_tbl[1].edx;
	for (n = 31; 0 <= n; n--){
		b = x & 0x80000000;
		if (b){
			_ftprintf(fp, _TEXT("\t\t%0.2d:%s\n"), n, edx1_str[31 - n]);
		}
		x = x << 1;
	}
	DWORD CorePlus_Mask_Width, SMT_Mask_Width;
	getEmuAPICBit(&CorePlus_Mask_Width, &SMT_Mask_Width);
	_ftprintf(fp, _TEXT("\t\tSMT_Mask_Width\t%d\n"), SMT_Mask_Width);
	_ftprintf(fp, _TEXT("\t\tCorePlus_Mask_Width\t%d\n"), CorePlus_Mask_Width);

}
CACHE_CODE* CPU_PKG::cpuid2_cache_find(DWORD code){
	DWORD n;
							//code, type, level, way, size(kb), line
	static CACHE_CODE cache0x49 =	{ 0x49, 3, 2, 16, 4096, 64 };
	if(code==0x49){
		EAX1 eax1;
		eax1.dword=cpuid_tbl[1].eax;
		if(!(eax1.family==0xf && eax1.model==6))
			return &cache0x49;
	}
	for (n = 0; cache_code[n].code; n++){
		if (code == cache_code[n].code)
			return cache_code + n;
	}
	return 0;
}
void CPU_PKG::cpuid2_cache_set(DWORD c){
	CACHE_CODE* p;
	p = cpuid2_cache_find(c);
	if (p){
		cache[cache_max++] = *p;
	}
}
void CPU_PKG::cpuid2_info_put(FILE* fp){
	DWORD n;
	DWORD c;

	_ftprintf(fp, _TEXT("    CPUID in EAX=0x00000002\n"));
	DWORD tlb_max = cpuid2_tbl[0].eax & 0xff;
	for (n = 1; n <= tlb_max; n++){
		_ftprintf(fp, _TEXT("\t%d\t"), n);
		cpuid2_tbl[n - 1].put(fp);
		_ftprintf(fp, _TEXT("\n"), n);
		CACHE_CODE* p;
		if ((cpuid2_tbl[n - 1].eax & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].eax >> 24) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].eax >> 16) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].eax >> 8) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
		}
		if ((cpuid2_tbl[n - 1].ebx & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].ebx >> 24) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ebx >> 16) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ebx >> 8) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ebx) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
		}
		if ((cpuid2_tbl[n - 1].ecx & 0x80000000) == 0){

			c = (cpuid2_tbl[n - 1].ecx >> 24) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ecx >> 16) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ecx >> 8) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].ecx) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
		}
		if ((cpuid2_tbl[n - 1].edx & 0x80000000) == 0){
			c = (cpuid2_tbl[n - 1].edx >> 24) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].edx >> 16) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].edx >> 8) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}
			c = (cpuid2_tbl[n - 1].edx) & 0xff;
			p = cpuid2_cache_find(c);
			if (p){
				_ftprintf(fp, _TEXT("\t%0.2x "), c);
				p->put(fp);
			}

		}
	}
	_ftprintf(fp, _TEXT("\n"), n);
}
void CPU_PKG::cpuid4_info_put(FILE *fp){
	DWORD n;
	for (n = 0; n < cpuid4_max; n++){
		_ftprintf(fp, _TEXT("    CPUID in EAX=0x00000004\tECX=0x%0.8x\n"), n);
		EAX4& eax4 = *(EAX4*)&cpuid4_tbl[n].eax;
		EBX4& ebx4 = *(EBX4*)&cpuid4_tbl[n].ebx;
		if ((cpuid4_tbl[n].eax & 0xf) == 0)
			break;
		int nNumberSets = cpuid4_tbl[n].ecx;
		_ftprintf(fp, _TEXT("\t%iLevel %s  %icore\n"), eax4.nCacheLevel, cache_type_str(eax4.nCacheType), eax4.nCores + 1);
		_ftprintf(fp, _TEXT("\t%s %s\n"), eax4.bSelfInit ? _TEXT("Self Initializing") : _TEXT("Self Initializing"), eax4.bFullyAssociative ? _TEXT("Fully Associatve") : _TEXT("Not Fully Associatve"));
		_ftprintf(fp, _TEXT("\t%iThreads LineSize %i Physical Line Partions %i\n"), eax4.nMaxThread + 1, ebx4.nSysLineSize + 1, ebx4.nPhysicalLinePartitions + 1);
		_ftprintf(fp, _TEXT("\t%iWays %iSets\n"), ebx4.nWaysAssociativity + 1, nNumberSets + 1);
		DWORD sz = (ebx4.nWaysAssociativity + 1)*(ebx4.nPhysicalLinePartitions + 1) * (ebx4.nSysLineSize + 1)*(nNumberSets + 1);
		_ftprintf(fp, _TEXT("\t\t%ibytes"), sz);
		if (sz / 1024 > 0)
			_ftprintf(fp, _TEXT(" %ikbytes"), sz / 1024);
		double szf = double(sz) / 1024.0 / 1024.0;
		if (1 <= szf)
			_ftprintf(fp, _TEXT(" %.1fMbytes"), szf);
		_ftprintf(fp, _TEXT("\n"));
	}
}
void CPU_PKG::cpuid7_info_put(FILE* fp){
	int n;
	DWORD x, b;
	_ftprintf(fp, _TEXT("    CPUID in EAX=0x00000007\n"));
	_ftprintf(fp, _TEXT("\tEBX\t0x%0.8x\n"), cpuid7_tbl[0].ebx);
	x = cpuid7_tbl[0].ebx;
	for (n = 31; 0 <= n; n--){
		b = x & 0x80000000;
		if (b){
			_ftprintf(fp, _TEXT("\t\t%0.2d:%s\n"), n, ebx7_str[31 - n]);
		}
		x = x << 1;
	}

	_ftprintf(fp, _TEXT("\tECX\t0x%0.8x\n"), cpuid7_tbl[0].ecx);
	x = cpuid7_tbl[0].ecx;
	for (n = 31; 0 <= n; n--){
		b = x & 0x80000000;
		if (b){
			_ftprintf(fp, _TEXT("\t\t%0.2d:%s\n"), n, ecx7_str[n]);
		}
		x = x << 1;
	}
}

void CPU_PKG::cpuid10_info_put(FILE *fp){
	int n;
	DWORD x, b;
	_ftprintf(fp, _TEXT("    CPUID in EAX=0x0000000A\n"));
	_ftprintf(fp, _TEXT("\tEAX\t0x%0.8x\n"), cpuid_tbl[0xa].eax);
	EAX10& eax10 = *(EAX10*)&cpuid_tbl[0xa].eax;
	EDX10& edx10 = *(EDX10*)&cpuid_tbl[0xa].edx;
	_ftprintf(fp, _TEXT("\t\trW %d\n"), eax10.ver);
	_ftprintf(fp, _TEXT("\t\t1_vZbT[ɑ΂PeMoJE^[ %d\n"), eax10.pemoCounter);
	_ftprintf(fp, _TEXT("\t\tPeMoJE^[̃rbg %d\n"), eax10.pemoBitWidth);
	_ftprintf(fp, _TEXT("\t\tEBXrbgxN^[ %d\n"), eax10.ebxVecWidth);

	x = cpuid_tbl[0xa].ebx;
	for (n = 31; 0 <= n; n--){
		b = x & 0x80000000;
		if (b){
			_ftprintf(fp, _TEXT("\t\t%0.2d:%s\n"), n, ebx10_str[31 - n]);
		}
		x = x << 1;
	}
	_ftprintf(fp, _TEXT("\t\tŒ@\PeMoJE^[̐ %d\n"), edx10.pemoCounterNum);
	_ftprintf(fp, _TEXT("\t\tŒ@\PeMoJE^[̃rbg %d\n"), edx10.pemoCounterWidth);

}

void CPU_PKG::cpuid11_info_put(FILE *fp){
	DWORD n;
	for (n = 0; n < cpuid11_max; n++){
		_ftprintf(fp, _TEXT("    CPUID in EAX=0x0000000B ECX=0x%0.8x\n"), n);
		EAX11& eax11 = *(EAX11*)&cpuid11_tbl[n].eax;
		EBX11& ebx11 = *(EBX11*)&cpuid11_tbl[n].ebx;
		ECX11& ecx11 = *(ECX11*)&cpuid11_tbl[n].ecx;
		_ftprintf(fp, _TEXT("\tEAX\t0x%0.8x\n"), cpuid11_tbl[n].eax);
		_ftprintf(fp, _TEXT("\t\tVtg%d\n"), eax11.x2APIC_ID);
		_ftprintf(fp, _TEXT("\tEBX\t0x%0.8x\n"), cpuid11_tbl[n].ebx);
		_ftprintf(fp, _TEXT("\t\tlevel %d\n"), ebx11.level);
		_ftprintf(fp, _TEXT("\tECX\t0x%0.8x\n"), cpuid11_tbl[n].ecx);
		_ftprintf(fp, _TEXT("\t\tECXinput %d\n"), ecx11.number);
		_ftprintf(fp, _TEXT("\t\ttype %d %s\n"), ecx11.type, ecx11_level_str[ecx11.type]);
	}
}

void CPU_PKG::cpuid80000008_info_put(FILE *fp){
	EAX80000008 eax8;
	eax8.dword= cpuid80000000_tbl[8].eax;
	_ftprintf(fp, _TEXT("    CPUID in EAX=0x80000008\n"));
	_ftprintf(fp, _TEXT("\t\tzAhXTCY %dbit\n"), eax8.vpad);
	_ftprintf(fp, _TEXT("\t\tAhXTCY %dbit\n"), eax8.pads);
}


void CPU_PKG::cpuid_info_put(FILE *fp){
	DWORD n;
	TCHAR buf[256];
	_ftprintf(fp, _TEXT("    ڍ\n"));
	_ftprintf(fp, _TEXT("\tCore\t%d \n\tThread\t%d \n"), coreMax, threadMax);
	ext_inst_str(buf, sizeof(buf) / sizeof(TCHAR));
	_ftprintf(fp, _TEXT("\t%s\n"), buf);

	cache_put(fp);
	_ftprintf(fp, _TEXT("    CPUg|W[\n"));
	_ftprintf(fp, _TEXT("\t_CPU RA Xbh(Windowst)\n"));
	for (n = 0; n < threadMax; n++){
		_ftprintf(fp, _TEXT("\t %7d %10d %10d\n"), n, corevec[n], threadvec[n]);
	}

	for (n = 0; n < cpuid_max; n++){
		switch (n){
		case  1:	cpuid1_info_put(fp); break;
		case  2:	cpuid2_info_put(fp); break;
		case  4: 	cpuid4_info_put(fp); break;
		case  7: 	cpuid7_info_put(fp); break;
		case 10: 	cpuid10_info_put(fp); break;
		case 11: 	cpuid11_info_put(fp); break;
		}
	}
	for (n = 0; n <= cpuid80000000_max; n++){
		switch (n){
		case 8:		cpuid80000008_info_put(fp); break;
		}
	}
}


TCHAR* CPU_PKG::ext_inst_str(TCHAR* buf, int sz){
	REG32 reg32;
	buf[0] = 0;
	for (int n = 0; ext_inst[n].str; n++){
		if (0x80000000 <= ext_inst[n].eax){
			cpuid(0, reg32.vec, 0x80000000);
			if (ext_inst[n].eax > reg32.eax)
				continue;
		}else{
			cpuid(0, reg32.vec, 0x00000000);
			if (ext_inst[n].eax > reg32.eax)
				continue;
		}

		if (ext_inst[n].eax == 7 && 7<=cpuid_tbl[0].eax)
			cpuidex(0, reg32.vec, ext_inst[n].eax,0);
		else
			cpuid(0, reg32.vec, ext_inst[n].eax);
		DWORD reg = reg32.vec[ext_inst[n].reg];
		DWORD mask = (1 << ext_inst[n].bit);
		if (reg & mask){
			_tcscat_s(buf, sz, ext_inst[n].str);
			_tcscat_s(buf, sz, _TEXT(" "));
		}
	}
	return buf;
}

void CPU_PKG::cpuid11_small_put(FILE* fp){
	for (DWORD u = 0; u < cpuid11_max; u++){
		_ftprintf(fp, _TEXT("\t0x%0.8x 0x%0.8x\t- "), 0xb, u);
		cpuid11_tbl[u].put(fp);
		_ftprintf(fp, _TEXT("\n"));
	}
}
void CPU_PKG::cpuid_put(FILE* fp){	//	pbP[WCPUIDt@Cɏo
	DWORD n, u;
	_ftprintf(fp, _TEXT("    WX^\n"));
	_ftprintf(fp, _TEXT("\tin EAX     in ECX     \t- out EAX    , out EBX     , out ECX    , out EDX\n"));

	for (n = 0; n < cpuid_max; n++){
		switch (n){
		case 2:{
				   for (u = 0; u < cpuid2_max; u++){
					   _ftprintf(fp, _TEXT("\t0x%0.8x 0x%0.8x\t- "), n, u);
					   cpuid2_tbl[u].put(fp);
					   _ftprintf(fp, _TEXT("\n"));
				   }
				   break;
		}
		case 4:{
				   for (u = 0; u < cpuid4_max; u++){
					   _ftprintf(fp, _TEXT("\t0x%0.8x 0x%0.8x\t- "), n, u);
					   cpuid4_tbl[u].put(fp);
					   _ftprintf(fp, _TEXT("\n"));
				   }
				   break;
		}
		case 7:{
				   for (u = 0; u < cpuid7_max; u++){
					   _ftprintf(fp, _TEXT("\t0x%0.8x 0x%0.8x\t- "), n, u);
					   cpuid7_tbl[u].put(fp);
					   _ftprintf(fp, _TEXT("\n"));
				   }
				   break;
		}
		case 11:{
					for (u = 0; u < cpuid11_max; u++){
						_ftprintf(fp, _TEXT("\t0x%0.8x 0x%0.8x\t- "), n, u);
						cpuid11_tbl[u].put(fp);
						_ftprintf(fp, _TEXT("\n"));
					}
					break;
		}
		default:
			_ftprintf(fp, _TEXT("\t0x%0.8x\t\t- "), n);
			cpuid_tbl[n].put(fp);
			_ftprintf(fp, _TEXT("\n"));
		}
	}

	for (n = 0x80000000; n < cpuid80000000_max + 0x80000000; n++){
		_ftprintf(fp, _TEXT("\t0x%0.8x\t\t- "), n);
		cpuid80000000_tbl[n - 0x80000000].put(fp);
		_ftprintf(fp, _TEXT("\n"));
	}

	_ftprintf(fp, _TEXT("    APIC CPUID in EAX=1 out EBX[31:24]\n"));
	_ftprintf(fp, _TEXT("\tThread\t"));
	for (n = 0; n < threadMax; n++){
		_ftprintf(fp, _TEXT("   %2i "), n);
	}
	_ftprintf(fp, _TEXT("\n"));

	_ftprintf(fp, _TEXT("\tAPIC\t"), n);
	for (n = 0; n < threadMax; n++){
		_ftprintf(fp, _TEXT(" 0x%0.2x "), apic[n]);
	}
	_ftprintf(fp, _TEXT("\n"));
	if (11 < cpuid_max){
		_ftprintf(fp, _TEXT("    x2APIC CPUID in EAX=11 out EDX\n"));
		_ftprintf(fp, _TEXT("\n\tx2APIC\t"), n);
		_ftprintf(fp, _TEXT("\tThread\t"));
		for (n = 0; n < threadMax; n++){
			_ftprintf(fp, _TEXT("    %2i "), n);
		}
		_ftprintf(fp, _TEXT("\n"));
		for (n = 0; n < threadMax; n++){
			_ftprintf(fp, _TEXT("0x%0.4x "), x2apic[n]);
		}
		_ftprintf(fp, _TEXT("\n"));
	}
}
void CPU_PKG::cpuid_put_ListView(HWND hList){
	LV_ITEM item;
	TCHAR buf[64];
	DWORD n, u;
	int num = 0;
	for(n = 0; n < cpuid_max; n++){
		switch (n){
		case 2:{
			for(u = 0; u < cpuid2_max; u++){
				item.mask = LVIF_TEXT | LVIF_PARAM;
				item.pszText = _TEXT("0x00000002");
				item.iItem = num;
				item.iSubItem = 0;
				item.lParam = num;
				ListView_InsertItem(hList, &item);

				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%d"), u);
				item.mask = LVIF_TEXT;
				item.pszText = buf;
				item.iItem = num;
				item.iSubItem = 1;
				ListView_SetItem(hList, &item);
				REG32 reg;
				cpuid(0, reg.vec, 2);
				reg.put_listview(hList, num++);
			}
			break;
		}
		case 4:{
			for(u = 0; u < cpuid4_max; u++){
				item.mask = LVIF_TEXT | LVIF_PARAM;
				item.pszText = _TEXT("0x00000004");
				item.iItem = num;
				item.iSubItem = 0;
				item.lParam = num;
				ListView_InsertItem(hList, &item);

				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), u);
				item.mask = LVIF_TEXT;
				item.pszText = buf;
				item.iItem = num;
				item.iSubItem = 1;
				ListView_SetItem(hList, &item);
				cpuid4_tbl[u].put_listview(hList, num++);
			}
			break;
		}
		case 7:{
			for(u = 0; u < cpuid7_max; u++){
				item.mask = LVIF_TEXT | LVIF_PARAM;
				item.pszText = _TEXT("0x00000007");
				item.iItem = num;
				item.iSubItem = 0;
				item.lParam = num;
				ListView_InsertItem(hList, &item);

				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), u);
				item.mask = LVIF_TEXT;
				item.pszText = buf;
				item.iItem = num;
				item.iSubItem = 1;
				ListView_SetItem(hList, &item);
				cpuid7_tbl[u].put_listview(hList, num++);
			}
			break;
		}
		case 11:{
			for (u = 0; u < cpuid11_max; u++){
				item.mask = LVIF_TEXT | LVIF_PARAM;
				item.pszText = _TEXT("0x0000000b");
				item.iItem = num;
				item.iSubItem = 0;
				item.lParam = num;
				ListView_InsertItem(hList, &item);

				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), u);
				item.mask = LVIF_TEXT;
				item.pszText = buf;
				item.iItem = num;
				item.iSubItem = 1;
				ListView_SetItem(hList, &item);
				REG32 reg;
				cpuidex(0, reg.vec, 11,u);
				reg.put_listview(hList, num++);
			}
			break;
		}
		default:
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), n);
			item.mask = LVIF_TEXT | LVIF_PARAM;
			item.pszText = buf;
			item.iItem = num;
			item.iSubItem = 0;
			item.lParam = num;
			ListView_InsertItem(hList, &item);
			REG32 reg;
			cpuid(0, reg.vec, n);
			reg.put_listview(hList, num++);
		}
	}
	for (n = 0x80000000; n < cpuid80000000_max + 0x80000000; n++){
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("0x%0.8x"), n);
		item.mask = LVIF_TEXT | LVIF_PARAM;
		item.pszText = buf;
		item.iItem = num;
		item.iSubItem = 0;
		item.lParam = num;
		ListView_InsertItem(hList, &item);
		cpuid80000000_tbl[n - 0x80000000].put_listview(hList, num++);
	}
}

void CPU_PKG::getCPUID(void){	//	pbP[WCPUID擾

	DEBUG_MSG_STR("CPU_PKG::getCPUID() Jn܂");

	emu = false;
	HANDLE h;
	h = GetCurrentThread();

	DEBUG_MSG_STR("CPU_PKG::getCPUID() SetThreadAffinityMask Jn܂");

	SetThreadAffinityMask(h, 1 << threadvec[0]);	//	CPU𕨗pbP[W̍ŏ̃RAɌŒ

	REG32 reg;
	__cpuid(reg.vec, 0x00000000);
	DWORD max = reg.eax;
	DWORD n,u;
	cpuid_max = reg.eax+1;
	cpuid_tbl = new REG32[cpuid_max];
	cpuid_tbl[0] = reg;

	for (n = 1; n < cpuid_max; n++){
		switch (n){
		case 2:{
			__cpuid(reg.vec, 0x00000002);
			cpuid_tbl[n] = reg;
			cpuid2_max = reg.eax & 0xff;
			cpuid2_tbl = new REG32[cpuid2_max];
			cpuid2_tbl[0] = reg;
			for(u = 1; u < cpuid2_max; u++){
				__cpuid(reg.vec, 0x00000002);
				cpuid2_tbl[u] = reg;
			}
			break;
		}
		case 4:{
			u = 0;
			REG32 temp[16];
			for(;;){
				__cpuidex(reg.vec, 0x00000004, u);
				if (u == 0)
					cpuid_tbl[n] = reg;
				if ((reg.eax & 0xf) == 0)
				   break;
				temp[u] = reg;
				++u;
			}
			cpuid4_max = u;
			cpuid4_tbl = new REG32[cpuid4_max];
			for (u = 0; u < cpuid4_max; u++){
				cpuid4_tbl[u] = temp[u];
			}
			break;
		}
		case 7:{
			for(u = 0;; u++){
				__cpuidex(reg.vec, 0x00000007, u);
				++u;
				if (reg.eax == 0)
					break;
			}
			cpuid7_max = u;
			cpuid7_tbl = new REG32[cpuid7_max];
			for(u = 0; u<cpuid7_max; u++){
				__cpuidex(reg.vec, 0x00000007, u);
				if (u == 0)
					cpuid_tbl[n] = reg;
			cpuid7_tbl[u] = reg;
			}
			break;
		}
		case 11:{
			u = 0;
			for(;;){
				__cpuidex(reg.vec, 0x0000000b, u);
				if(u == 0)
					cpuid_tbl[n] = reg;
				if(reg.eax == 0 && reg.ebx == 0)
					break;
				++u;
			}
			cpuid11_max = (u == 0) ? 1 : u;
			cpuid11_tbl = new REG32[cpuid11_max];
			for (u = 0; u < cpuid11_max; u++){
				__cpuidex(reg.vec, 0x0000000b, u);
				cpuid11_tbl[u] = reg;
			}
			break;
		}
		case 13:{
			u = 0;
			REG32 temp[16];
			for(;;){
				__cpuidex(reg.vec, 0x0000000d, u);
				if(u == 0)
					cpuid_tbl[n] = reg;
				if(reg.eax == 0)
					break;
				temp[u] = reg;
				++u;
			}
			cpuid13_max = u;
			cpuid13_tbl = new REG32[cpuid13_max];
			for(u = 0; u < cpuid13_max; u++){
				cpuid13_tbl[u] = temp[u];
			}
			break;

		}
		default:
			__cpuid(reg.vec, n);
			cpuid_tbl[n] = reg;
		}
	}

	__cpuid(reg.vec, 0x80000000);
	cpuid80000000_max = reg.eax - 0x80000000 + 1;
	cpuid80000000_tbl = new REG32[cpuid80000000_max + 1];
	cpuid80000000_tbl[0] = reg;
	for (n = 0x80000001; n < cpuid80000000_max + 0x80000000; n++){
		__cpuid(reg.vec, n);
		cpuid80000000_tbl[n - 0x80000000] = reg;
	}

	cpunameA = (char*)&cpuid80000000_tbl[2];
#ifdef UNICODE
	for(n = 0; n < 48; n++)
		name[n] = cpunameA[n];
#else
	name = cpunameA;
#endif
	apic = new DWORD[threadMax];
	x2apic = new DWORD[threadMax];

	for(n = 0; n < threadMax; n++){
		SetThreadAffinityMask(h, 1 << threadvec[n]);	//	CPU𕨗pbP[W̍ŏ̃RAɌŒ
		__cpuid(reg.vec, 0x00000001);
		apic[n] = reg.ebx >> 24;
		if (0xb <= cpuid_tbl[0].eax){	//	x2apicT|[gĂ
			__cpuidex(reg.vec, 0x0000000b, 0);
			x2apic[n] = reg.edx;
		}
		else
			x2apic[n] = 0;
	}
	cache_set();
}

void CPU_PKG::cpuid(int thread, int* info, int eax){
	if(eax<0x80000000){
		info[0] = cpuid_tbl[eax].eax;
		info[1] = cpuid_tbl[eax].ebx;
		info[2] = cpuid_tbl[eax].ecx;
		info[3] = cpuid_tbl[eax].edx;
		if (eax == 1){
			info[1] = cpuid_tbl[eax].ebx + (apic[thread] << 24);
		}
	}
	else{
		info[0] = cpuid80000000_tbl[eax - 0x80000000].eax;
		info[1] = cpuid80000000_tbl[eax - 0x80000000].ebx;
		info[2] = cpuid80000000_tbl[eax - 0x80000000].ecx;
		info[3] = cpuid80000000_tbl[eax - 0x80000000].edx;
	}
}
void CPU_PKG::cpuidex(int thread, int* info, int eax, int ecx){
	switch (eax){
	case 4:
		info[0] = cpuid4_tbl[ecx].eax;
		info[1] = cpuid4_tbl[ecx].ebx;
		info[2] = cpuid4_tbl[ecx].ecx;
		info[3] = cpuid4_tbl[ecx].edx;
		break;
	case 7:
		info[0] = cpuid7_tbl[ecx].eax;
		info[1] = cpuid7_tbl[ecx].ebx;
		info[2] = cpuid7_tbl[ecx].ecx;
		info[3] = cpuid7_tbl[ecx].edx;
		break;
	case 11:
		info[0] = cpuid11_tbl[ecx].eax;
		info[1] = cpuid11_tbl[ecx].ebx;
		info[2] = cpuid11_tbl[ecx].ecx;
		info[3] = cpuid11_tbl[ecx].edx + x2apic[thread];
		break;
	case 13:
		info[0] = cpuid13_tbl[ecx].eax;
		info[1] = cpuid13_tbl[ecx].ebx;
		info[2] = cpuid13_tbl[ecx].ecx;
		info[3] = cpuid13_tbl[ecx].edx;
		break;
	default:
		cpuid(thread, info, eax);
		break;
	}
}
CPU_PKG::CPU_PKG(){
	cx = 64;
	cy = 32;
	px = 8;
	py = 16;
	cache_max = 0;
	emu = true;
}

//	CPUg|W[̎擾

void CPU_PKG::GetTopology(DWORD apic, DWORD* pkg, DWORD* core, DWORD* smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width){
	DWORD SMT_Select_Mask = ~(0xffffffff << SMT_Mask_Width);
	*smt = apic & SMT_Select_Mask;
	DWORD CoreOnly_Select_Mask = (~(0xffffffff << CorePlus_Mask_Width)) ^ SMT_Select_Mask;
	*core = (apic & CoreOnly_Select_Mask) >> SMT_Mask_Width;
	DWORD Pkg_Select_Mask = 0xffffffff << CorePlus_Mask_Width;
	*pkg = (apic & Pkg_Select_Mask) >> CorePlus_Mask_Width;
}

void CPU_PKG::SetTopology(DWORD* apic, DWORD pkg, DWORD core, DWORD smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width){
	DWORD v;
	DWORD SMT_Select_Mask = ~(0xffffffff << SMT_Mask_Width);
	v = smt & SMT_Select_Mask;

	DWORD CoreOnly_Select_Mask = (~(0xffffffff << CorePlus_Mask_Width)) ^ SMT_Select_Mask;
	v = v | ((core << SMT_Mask_Width) & CoreOnly_Select_Mask);
	v = v | (pkg << CorePlus_Mask_Width);
	*apic = v;
}

//	CPUg|W[̃rbgʒu̎擾
DWORD CPU_PKG::getTopologyBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width){
	REG32 reg;
	bool x2=isX2apic();
	if (x2 == true){	//	CPUID͊gg|WT|[g (x2APIC ID)
		__cpuidex(reg.vec, 11, 0);	//	SMT
		if (((reg.ecx >> 8) & 0xff) == 1){
			*SMT_Mask_Width = reg.eax & 0x1f;
		}
		__cpuidex(reg.vec, 11, 1);	//	Core
		if (((reg.ecx >> 8) & 0xff) == 2){
			*CorePlus_Mask_Width = reg.eax & 0x1f;
		}
		return reg.edx;
	}
	else{	// Pentium4 PentiumD Core2Duo Core2QuadEAX=11T|[gĂȂ̂Ń[JAPIC擾
		__cpuid(reg.vec, 0x01);
		unsigned lapic = ((unsigned)reg.ebx >> 24) & 0xff;
		unsigned lCpu = (reg.ebx >> 16) & 0xff;	//	_CPU

		__cpuidex(reg.vec, 0x04, 0x00);
		unsigned temp = (reg.eax >> 26) & 0x3f;
		unsigned d = 0;
		if (lCpu)
			d = lapic / (lCpu + 1);

		*SMT_Mask_Width = bit_count(lCpu) / (temp + 1);
		DWORD CoreOnly_Mask_Width = bit_count(temp + 1);

		*CorePlus_Mask_Width = CoreOnly_Mask_Width + *SMT_Mask_Width;
		return lapic;
	}
}
//	CPUg|W[̃rbgʒu̎擾
void CPU_PKG::getEmuAPICBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width){
	REG32 reg = cpuid_tbl[1];
	unsigned lapic = ((unsigned)reg.ebx >> 24) & 0xff;
	unsigned lCpu = (reg.ebx >> 16) & 0xff;	//	_CPU
	reg = cpuid4_tbl[0];
	unsigned temp = (reg.eax >> 26) & 0x3f;
	unsigned d = 0;
	if(lCpu)
		d = lapic / (lCpu + 1);

	*SMT_Mask_Width = bit_count(lCpu) / (temp + 1);
	DWORD CoreOnly_Mask_Width = bit_count(temp + 1);

	*CorePlus_Mask_Width = CoreOnly_Mask_Width + *SMT_Mask_Width;
	return;
}

//	CPUg|W[̃rbgʒu̎擾
bool CPU_PKG::getEmuX2apicBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width){
	REG32 reg = cpuid_tbl[0];
	if(11 <= reg.eax){	//	CPUID͊gg|WT|[g (x2APIC ID)
		reg = cpuid11_tbl[0];
		if(((reg.ecx >> 8) & 0xff) == 1){
			*SMT_Mask_Width = reg.eax & 0x1f;
		}
		reg = cpuid11_tbl[1];
		if(((reg.ecx >> 8) & 0xff) == 2){
			*CorePlus_Mask_Width = reg.eax & 0x1f;
		}
		return true;
	}
	else
		return false;
}

void CPU::cpuid_put(FILE* fpv){
	DEBUG_MSG_STR("CPU::cpuid_put() Jn܂");

	DWORD n;
	_ftprintf(fpv, _TEXT("VXeCPU\\n"));
	for(n = 0; n < pkgMax; n++){
		_ftprintf(fpv, _TEXT("  pbP[W%d\t%s\n"),n,cpu_pkg[n]->name);
	}
	_ftprintf(fpv, _TEXT("CPUID߂̏o͌\n"));
	for(n = 0; n < pkgMax; n++){
		_ftprintf(fpv, _TEXT("  pbP[W%d\t%s\n"), n, cpu_pkg[n]->name);
		cpu_pkg[n]->cpuid_put(fpv);
	}
}

void CPU::cpuid_info_put(FILE* fpv){
	DEBUG_MSG_STR("CPU::cpuid_info_put() Jn܂");
	_ftprintf(fpv, _TEXT("CPUID߂̏o͂̉͌\n"));
	for(DWORD n = 0; n < pkgMax; n++){
		_ftprintf(fpv, _TEXT("  pbP[W %d\n"), n);
		cpu_pkg[n]->cpuid_info_put(fpv);
	}
}

void CPU::init(void){	//	ǉꂽcpuɑ΂apic,x2apicB
	DWORD n, u, i;
	lCpuMax = 0;
	for(n = 0; n < pkgMax; n++){
		lCpuMax += cpu_pkg[n]->threadMax;
	}
	smt = new DWORD[lCpuMax];
	core = new DWORD[lCpuMax];
	pkg = new DWORD[lCpuMax];
	temp = new DWORD[lCpuMax];
	i = 0;
	static DWORD p, c, s;
	for (n = 0; n < pkgMax; n++){
		DWORD CorePlus_Mask_Width, SMT_Mask_Width;
		for (u = 0; u < cpu_pkg[n]->threadMax; u++){
			cpu_pkg[n]->getEmuAPICBit(&CorePlus_Mask_Width, &SMT_Mask_Width);
			cpu_pkg[n]->GetTopology(cpu_pkg[n]->apic[u], &p, &c, &s, CorePlus_Mask_Width, SMT_Mask_Width);
			cpu_pkg[n]->SetTopology(cpu_pkg[n]->apic + u, n, c, s, CorePlus_Mask_Width, SMT_Mask_Width);
			if (cpu_pkg[n]->getEmuX2apicBit(&CorePlus_Mask_Width, &SMT_Mask_Width) == true){
				cpu_pkg[n]->GetTopology(cpu_pkg[n]->x2apic[u], &p, &c, &s, CorePlus_Mask_Width, SMT_Mask_Width);
				cpu_pkg[n]->SetTopology(cpu_pkg[n]->x2apic + u, n, c, s, CorePlus_Mask_Width, SMT_Mask_Width);
			}
			smt[i] = s;
			core[i] = c;
			pkg[i] = n;
			cpu_pkg[n]->corevec[u] = core[n];
			cpu_pkg[n]->threadvec[u] = i;
			++i;
		}
	}
	emu_cpu_num = new int[lCpuMax];
	alloc_cpu(emu_cpu_num, lCpuMax);
	mask = 0;
//	ׂẲzCPUԍɑ΂ăXbh蓖Ă
	UINT64 bit = 1;
	for (n = 0; n < lCpuMax; n++){
		mask = mask | bit;
		bit = bit << 1;
	}
	sysmask = mask;
}
//	w肵pbP[WԍCPUǉ
void CPU::add(int package, CPU_PKG* cpu){
	cpu_pkg[package] = cpu;
}
//	VXeCPUIDsʂ𒊏oB
void CPU::getCPUID(void){
	for(DWORD n = 0; n < pkgMax; n++){
		cpu_pkg[n]->getCPUID();
	}
}

int CPU::bit_num(UINT64 bit){	//	1̃rbg擾
	int count = 0;
	int vmask = 1;
	for (int n = 0; n < sizeof(bit)* 8; n++){
		if (vmask & bit){
			++count;
		}
		vmask = vmask << 1;
	}
	return count;
}

DWORD_PTR CPU::emuSetThreadAffinityMask(HANDLE h, UINT64 vmask){	//	sCPUŒ
	mask = vmask;
	if (emu_cpu_num){
		UINT64 bmask = 0;
		for (int n = 0; n <sizeof(vmask)*8; n++){
			int b = emu_cpu_num[n];
			UINT64 bset = ((UINT64)1 << (b));
			bmask = bmask | bset;
		}

		FILE* fp;
		_tfopen_s(&fp, _TEXT("cpuid.txt"), _TEXT("a+,ccs=UNICODE"));
		_ftprintf(fp, _TEXT("%0.16lx %0.16lx\n"), vmask,bmask);
		fclose(fp);


		return ::SetThreadAffinityMask(h, (DWORD_PTR)bmask);	//	zCPUCPUɊ蓖Ă
	}
	return 0;
}
BOOL CPU::emuGetProcessAffinityMask(HANDLE h, UINT64* vmask, UINT64* vsysmask){	//	sCPU擾
	*vmask = mask;
	*vsysmask = sysmask;
	return TRUE;
}

void CPU::emuGetSystemInfo(SYSTEM_INFO* sys){
	::GetSystemInfo(sys);
	sys->dwNumberOfProcessors = lCpuMax;
}
void CPU::cpuid(int* info, int eax){	//	擾ꂽcpuidɂG~[V
	int cpu_num, pkg_num, thread_num;
	make_cpuid_para(&cpu_num, &pkg_num, &thread_num);
	cpu_pkg[pkg_num]->cpuid(thread_num, info, eax);
}
void CPU::cpuidex(int* info, int eax, int ecx){	//	擾ꂽcpuidɂG~[V
	int cpu_num, pkg_num, thread_num;
	make_cpuid_para(&cpu_num, &pkg_num, &thread_num);
	cpu_pkg[pkg_num]->cpuidex(thread_num, info, eax, ecx);
}


#ifdef CPUIDEX_ACTIVE
	#ifdef _WIN64
		#error Visual C++ 2010̏ꍇ32bitŃRpCĂB
	#endif
	//	Visual C++ 2008 Express SP1__cpuid֐T|[gĂ̂ŃRgAEgB
	void __cpuidex(int* info,int _eax,int _ecx){
		_asm{
			mov	eax,_eax
			mov ecx,_ecx
			mov esi,info
			cpuid
			mov [esi],eax
			mov [esi+4],ebx
			mov [esi+8],ecx
			mov [esi+12],edx
		}
	}
#endif