﻿#ifndef CPU_H

#define CPU_H 0x02
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <commctrl.h>

#if 0	//	__cpuid 関数をサポートしていないコンパイラを使用する場合は有効にする
	void __cpuidex(int* info,int _eax,int _ecx);
	#define CPUIDEX_ACTIVE	1
#endif


#if 0	//	デバック用
	inline void msg_ini(TCHAR* msg, int n){
		TCHAR buf[256];
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%s\r\n%i"), msg, n);
		MessageBox(0, buf, _TEXT("デバック情報"), MB_OK);
	}

	#define DEBUG_MSG_STR(msg) MessageBox(0, _TEXT(msg), _TEXT("デバック情報"), MB_OK);
	#define DEBUG_MSG_INI(msg,value) msg_ini(msg,value) 
#else
	#define	DEBUG_MSG_STR(msg) {}
	#define DEBUG_MSG_INI(msg,value) {}
#endif

//	論理CPU数を取得する
//int GetCPUMax(void);
void GetCpuName(TCHAR* cpuname);
//	必要なbit数を取得する
int bit_count(DWORD d);

//	cpuidで取得されたCPU名を短縮する

void shortCpuName(TCHAR* dtc, int sz, TCHAR* cpuname);


union REG32{
	int vec[4];
	struct {
		DWORD eax, ebx, ecx, edx;
	};
	void put(FILE* fp){
		_ftprintf(fp, _TEXT("0x%0.8x , 0x%0.8x , 0x%0.8x ,0x%0.8x "), eax, ebx, ecx, edx);
	}
	void put_listview(HWND hList, int num);
};

union EAX1{
	DWORD dword;
	struct{
		unsigned stepping : 4;		//	00	ステッピング
		unsigned model : 4;			//	04	モデル
		unsigned family : 4;		//	08	ファミリ
		unsigned processer_type : 2;//	12	Intelプロセッサの種類 
		unsigned resaved1 : 2;		//	14	予約済み
		unsigned ex_model : 4;		//	16	拡張モデル
		unsigned ex_family : 8;		//	20	拡張ファミリ
		unsigned resaved2 : 4;		//	28	予約済み
	};
	operator DWORD(){
		return dword;
	}
};

union EBX1{
	DWORD dword;
	struct{
		unsigned brand_index : 8;	//	00	ブランドインデックス	
		unsigned line_size : 8;	//	08	クワドワードの CLFLUSH キャッシュの行のサイズ
		unsigned processer : 8;	//	16	論理プロセッサの数
		unsigned apic_id : 8;		//	24	プロセッサのローカルAPICの物理ID
	};
};

union ECX1{
	DWORD dword;
	struct {
		unsigned sse3 : 1;		//	00	ストリーミングSIMD拡張命令3
		unsigned pclmuldq : 1;	//	01	PCLMULDQ命令セット
		unsigned dtes64 : 1;		//	02	64bit Debug Store
		unsigned monitor : 1;		//	03	MONITOR命令/MWAIT命令
		unsigned ds_cpl : 1;		//	04	CPL Qualified Debug Store
		unsigned vmx : 1;			//	05	Virtual Machine Extensions
		unsigned smx : 1;			//	06	Virtual Machine Extensions
		unsigned eist : 1;		//	07	拡張版Intel SpeedStep®テクノロジ	 

		unsigned tm2 : 1;			//	08	温度モニタ2
		unsigned ssse3 : 1;		//	09	ストリーミングSIMD拡張命令3(SSSE3)
		unsigned cnxt_id : 1;		//	10	L1 ContextID
		unsigned rev41 : 1;		//	11	予約済み
		unsigned fma : 1;			//	12	Fused Multiply Add
		unsigned cx16 : 1;		//	13	CMPXCHG16B命令
		unsigned xtpr : 1;		//	14	xTPR Update Control
		unsigned pdcm : 1;		//	15	Perfmon and Debug Capability

		unsigned rev5 : 1;		//	16	予約済み
		unsigned pcid : 1;		//	17	Process Context Identifiers
		unsigned dca : 1;			//	18	Direct Cache Access
		unsigned sse4_1 : 1;		//	19	ストリーミングSIMD拡張命令4.1
		unsigned sse4_2 : 1;		//	20	ストリーミングSIMD拡張命令4.2
		unsigned x2apic : 1;		//	21	x2APIC
		unsigned movbe : 1;		//	22	MOVBE命令 
		unsigned popcnt : 1;		//	23	POPCNT命令

		unsigned tsc_deadline : 1;//	24	Time Stamp Counter Deadline
		unsigned aesni : 1;			//	25	AESNI命令セット
		unsigned xsave : 1;		//	26	XSAVW/XSTOR States
		unsigned osxsave : 1;		//	27	OS-Enabled-Extended State Management
		unsigned avx : 1;			//	28	AVX
		unsigned f16c : 1;		//	29	16-bit floating-point conversion instructions
		unsigned rdrand : 1;		//	30	RDRAND命令
		unsigned rev8 : 1;		//	31	予約済み
	};
};

union EDX1{
	DWORD dword;
	struct{
		unsigned fpu : 1;			//	00	オンチップFPU
		unsigned vme : 1;			//	01	仮想8086モード拡張機能
		unsigned de : 1;			//	02	デバック拡張機能
		unsigned pse : 1;			//	03	ページ サイズ拡張機能
		unsigned tsc : 1;			//	04	タイムスタンプカウンタ
		unsigned msr : 1;			//	05	RDMSR命令、WRMSR命令 
		unsigned pae : 1;			//	06	物理アドレス拡張機能(32bit以上)
		unsigned mce : 1;			//	07	マシンチェック例外(例外18 CR4.MCEイネブルビット)

		unsigned cx8 : 1;			//	08	CMPXCHG8B命令
		unsigned apic : 1;		//	09	オンチップAPICハードウェア
		unsigned rev5 : 1;		//	10	予約済み
		unsigned sep : 1;			//	11	SYSENTERとSYSEXIT(高速システムコール)
		unsigned mtrr : 1;		//	12	メモリタイプ範囲レジスタ(MTRR_CAP)
		unsigned pge : 1;			//	13	PDE・PTBのグローバルビット
		unsigned mca : 1;			//	14	マシンチェックアーキテクチャ(MCG_CAP)
		unsigned cmov : 1;		//	15	条件付き移動命令

		unsigned pat : 1;			//	16	ベージ属性テーブル
		unsigned pse_36 : 1;		//	17	36ビットページ サイズの拡張機能
		unsigned psn : 1;			//	18	プロセッサのシリアル番号
		unsigned clfsh : 1;		//	19	CFLUSH命令 
		unsigned rev6 : 1;		//	20	予約済み
		unsigned ds : 1;			//	21	デバックストア
		unsigned acpi : 1;		//	22	温度モニタとソフトウェア制御クロック機能
		unsigned mmx : 1;			//	23	MMXテクノロジ

		unsigned fxsr : 1;		//	24	FXSAVE命令/FXRSTOR命令
		unsigned sse : 1;			//	25	ストリーミングSIMD拡張命令
		unsigned sse2 : 1;		//	26	ストリーミングSIMD拡張命令2
		unsigned ss : 1;			//	27	自己スヌープ
		unsigned htt : 1;			//	28	ハイパースレッディングテクノロジ
		unsigned tm : 1;			//	29	温度モニタ
		unsigned rev7 : 1;		//	30	予約済み
		unsigned pbe : 1;			//	31	ペンディングブレークイネーブル
	};
};

extern TCHAR* ecx1_str[];
extern TCHAR* edx1_str[];

TCHAR* cache_type_str(int n);

struct CACHE_CODE{
	BYTE code;
	BYTE type;
	BYTE level;
	BYTE way;
	DWORD size;
	WORD line;
	WORD thread;	//	CPUID4 +1 の値
	WORD uThread;	//	キャッシュを共有するスレッド数
	WORD id_bit_mask;
	DWORD* apics;
	void put(FILE* fp){
		if (code == 0x40)
			return;
		if (type != 4)
			_ftprintf(fp, _TEXT("%s L%d %dway %dkb line size %d\n"), cache_type_str(type), level, way, size, line);
		else
			_ftprintf(fp, _TEXT("Trace Cache L%d %dway %dkμOPs\n"), level, way, size);
	}
	friend int cacheCmp(const void *dtcp, const void* srcp){
		CACHE_CODE& dtc = *(CACHE_CODE*)dtcp;
		CACHE_CODE& src = *(CACHE_CODE*)srcp;
		int f = (dtc.level - src.level) * 16 + (dtc.type - src.type);
		return f;
	}
};


extern CACHE_CODE cache_code[];

union EAX4{
	DWORD dword;
	struct {
		unsigned nCacheType : 5;	//	00		キャッシュタイプ
		unsigned nCacheLevel : 3;	//	05		キャッシュレベル
		unsigned bSelfInit : 1;	//	08	自己初期化するキャッシュレベル
		unsigned bFullyAssociative : 1;	//	09	フルアソシアティブキャッシュ
		unsigned rev : 4;			//	10
		unsigned nMaxThread : 12;	//	14	このキャッシュを共有するスレッド数
		unsigned nCores : 6;	//	26	ダイ上のプロセッサコア数
	};
	operator DWORD(){
		return dword;
	}
};

union EBX4{
	DWORD dword;
	struct{
		unsigned nSysLineSize : 12;	//	00	ラインサイズ
		unsigned nPhysicalLinePartitions : 10;	//	12	
		unsigned nWaysAssociativity : 10;	//	22	セット数
	};
	operator DWORD(){
		return dword;
	}
};


struct EBX7_0{
	unsigned FSGSBASE : 1; // 00 RDFSBASE/RDGSBASE/WRFSBASE/WRGSBASE
	unsigned TSC_ADJUST : 1; // 01 IA32_TSC_ADJUST MSR.
	unsigned rev1 : 1; // 02 Reserved
	unsigned BMI1 : 1; // 03 1st group bit manipulation extensions
	unsigned HLE : 1; // 04 Hardware Lock Elision
	unsigned AVX2 : 1; // 05 AVX2  instructions
	unsigned rev2 : 1; // 06 Reserved
	unsigned SMEP : 1; // 07 Supervisor-Mode Execution Prevention

	unsigned BMI2 : 1; // 08 2nd group bit manipulation extensions
	unsigned ERMS : 1; // 09 Enhanced REP MOVSB/STOSB
	unsigned INVPCID : 1; // 10Invalidate Processor Context ID 
	unsigned RTM : 1; // 11 RTM Restricted Transactional Memory
	unsigned PQM : 1; // 12 Platform Quality of Service Monitoring (PQM)
	unsigned FPUCS_DS : 1; // 13 Deprecates FPU CS and FPU DS
	unsigned MPX : 1; // 14 Intel Memory Protection Extensions
	unsigned PQE : 1; // 15 Platform Quality of Service Enforcement (PQE)

	unsigned AVX512F : 1; // 16
	unsigned AVX512DQ : 1; // 17
	unsigned RDSEED : 1; // 18 RDSEED instructions
	unsigned ADX : 1; // 19 The ADCX and ADOX instructions
	unsigned SMAP : 1; // 20 Supervisor Mode Access Prevention
	unsigned AVX512IFMA52 : 1; // 21
	unsigned rev4 : 1; // 22
	unsigned CLFLUSHOPT : 1; // 23

	unsigned rev5 : 1; // 24
	unsigned PT : 1; // 25 Intel Processor Trace
	unsigned AVX512PF : 1; // 26
	unsigned AVX512ER : 1; // 27
	unsigned AVX512CD : 1; // 28
	unsigned SHA : 1; // 29
	unsigned AVX512BW : 1; // 30
	unsigned AVX512VL : 1;// 31

};

struct ECX7_0{
	unsigned PREFETCHWT1 : 1;	//	00
	unsigned AVX512VBMI : 1;	//	01
	unsigned rev1 : 30;
};

extern TCHAR* ebx7_str[];
extern TCHAR* ecx7_str[];

struct EAX10{
	unsigned ver : 8;	//	00-07 Version ID
	unsigned pemoCounter : 8;	//	08-15 1論理プロセッサーに対するPeMoカウンター数
	unsigned pemoBitWidth : 8;	//	16-23 PeMoカウンターのビット幅
	unsigned ebxVecWidth : 8;	//	24-31 EBXビットベクター長
};

struct EDX10{
	unsigned pemoCounterNum : 5;	//	00-04 固定機能PeMoカウンターの数
	unsigned pemoCounterWidth : 8;	//	05-12 固定機能PeMoカウンターのビット幅
	unsigned rev : (32-13);	//	14-31 予約
};

extern TCHAR* ebx10_str[];

struct EAX11{
	unsigned x2APIC_ID : 4;	//	00	x2APIC ID
	unsigned rev : 28;	//	04
};

struct EBX11{
	unsigned level : 16;	//	00	number of enabled logical processors at this level
	unsigned rev : 16;	//	16
};

struct ECX11{
	unsigned number : 8;	//	00	level number
	unsigned type : 8;	//	08	level type 
	unsigned rev : 16;	//	16
};

extern TCHAR* ecx11_level_str[];

struct EAX13_0{
	unsigned Legacy_x87 : 1;	//	00	
	unsigned SSE128 : 1;	//	01 128bit-SSE
	unsigned AVX256 : 1;	//	02 AVX-256bit
};

struct EAX13_1{
	unsigned XSAVEOPT : 1;	//	00 XSAVEOPT
	unsigned XSAVEC : 1;	//	01 XSAVEC
	unsigned XGETBV : 1;	//	02 XGETBV
	unsigned XSAVES : 1;	//	03 XSAVES
};


union EAX80000008{
	DWORD dword;
	struct{
		unsigned pads : 8;	//物理アドレスサイズ(ビット数)
		unsigned vpad : 8;	//仮想アドレスサイズ(ビット数)
		unsigned rev : 16;
	};

};

struct EXT_INST{
	DWORD eax;
	DWORD reg;
	DWORD bit;
	TCHAR* str;
};

extern EXT_INST ext_inst[];

//	物理パッケージの情報

class CPU_PKG{
protected:
	friend class CPU;
	//	コアの大きさ
	int cx;
	int cy;
	//	パッケージとコアの距離
	int px;
	int py;
	bool emu;	//	エミュレーション時はtrue
public:
	DWORD coreMax;	//	コア数
	DWORD threadMax;	//	スレッド数
	CACHE_CODE cache[8];	//	キャッシュ情報	
	DWORD cache_max;	//	キャッシュ情報の個数
	int* threadvec;	//	CPU→論理CPU番号
	int* corevec;	//	CPU→コア
protected:
	REG32* cpuid_tbl;	//	eax=0～指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid_max;	//	cpuid_tblの要素数
	REG32* cpuid80000000_tbl;	//	eax=0x80000000～指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid80000000_max;	//	cpuid80000000_tblの要素数
	REG32* cpuid2_tbl;	//	eax=2で指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid2_max;	//	cpuid2_tblの要素数
	REG32* cpuid4_tbl;	//	eax=4 ,ecx指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid4_max;	//	cpuid4_tblの要素数
	REG32* cpuid7_tbl;	//	eax=7 ,ecx指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid7_max;	//	cpuid7_tblの要素数
	REG32* cpuid11_tbl;	//	eax=11,ecx指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid11_max;	//	cpuid11_tblの要素数
	REG32* cpuid13_tbl;	//	eax=13,ecx指定されるcpuidの実行結果のテーブル(継承側のクラスで定義する)
	DWORD cpuid13_max;	//	cpuid13_tblの要素数
	DWORD* apic;	//	論理CPUごとのAPIC値
	DWORD* x2apic;	//	論理CPUごとのx2APIC値
	char* cpunameA;	//	CPU名(ANSI)
public:
	TCHAR name[48];	//	CPU名
protected:
	void cache_set(void);	// cpuid EAX=2とcpuid EAX=4によりキャッシュ諸元を設定
	void cache_put(FILE* fp);	//	キャッシュ情報の出力
	void DrawOwn(HDC hdc, int sx, int sy, int cpuNum);	// 1個の物理CPUを描画
	void Draw(HDC hdc, int sx, int sy, int* ex, int* ey);	// 1個のパッケージを描画
	void cpuid1_info_put(FILE* fp);	//	cpuid EAX=1の実行結果を出力
	CACHE_CODE* cpuid2_cache_find(DWORD code);	//	cpuid EAX=2の実行結果よりキャッシュ情報を抽出
	void cpuid2_cache_set(DWORD c);	//	cpuid EAX=1の実行結果を出力
	void cpuid2_info_put(FILE* fp);	//	cpuid EAX=2の実行結果を出力
	void cpuid4_info_put(FILE *fp);	//	cpuid EAX=4の実行結果を出力
	void cpuid7_info_put(FILE* fp);	//	cpuid EAX=7の実行結果を出力
	void cpuid10_info_put(FILE *fp);	//	cpuid EAX=10の実行結果を出力
	void cpuid11_info_put(FILE *fp);	//	cpuid EAX=11の実行結果を出力
	void cpuid11_small_put(FILE* fp);	//	cpuid EAX=11の実行結果を出力(簡易)
	void cpuid80000008_info_put(FILE *fp);	//	cpuid EAX=0x80000008の実行結果を出力
	void getCPUID(void);	//	物理パッケージのCPUIDを取得

	//	CPUトポロジーの取得
	void GetTopology(DWORD apic, DWORD* pkg, DWORD* core, DWORD* smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width);
	//	CPUトポロジーの設定
	void SetTopology(DWORD* apic, DWORD pkg, DWORD core, DWORD smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width);
	//	CPUトポロジーのビット位置の取得
	DWORD getTopologyBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);
	//	CPUトポロジーのビット位置の取得(テーブルより)
	void getEmuAPICBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);
	//	CPUトポロジーのビット位置の取得(テーブルより)
	bool getEmuX2apicBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);
	//	CPU拡張トポロジーをサポートしているときはtrueを返す	
	bool emuIsX2apic(void){
		REG32 reg;
		bool x2 = false;
		reg.eax = cpuid_tbl[0].eax;
		if(11 <= reg.eax){
			reg = cpuid11_tbl[0];
			if(reg.eax == 0 && reg.ebx == 0)
				x2 = false;
			else
				x2 = true;
		}
		else
			x2 = false;
		return x2;
	}
	bool isX2apic(void){
		REG32 reg;
		bool x2 = false;
		__cpuid(reg.vec, 0x00);
		if (11 <= reg.eax){
			__cpuidex(reg.vec, 11, 0);
			if (reg.eax == 0 && reg.ebx == 0)
				x2 = false;
			else
				x2 = true;
		}
		else
			x2 = false;
		return x2;
	}
	CPU_PKG();

	void cpuid_info_put(FILE *fp);	//	cpuidの実行結果を全部出力
	void cpuid_cpp_put(FILE* fp, TCHAR* fname);	//	物理パッケージのCPUIDをC++のクラスとしてソースをファイルに出力
	void cpuid_put(FILE* fp);	//	取得されたcpuidをファイルに出力

public:
	void cpuid(int thread, int* info, int eax);	//	取得されたcpuidによりエミュレーション
	void cpuidex(int thread, int* info, int eax, int ecx);	//	取得されたcpuidによりエミュレーション
	TCHAR* ext_inst_str(TCHAR* buf, int sz);	//	サポートされている拡張命令を文字列化する
	void cpuid_put_ListView(HWND hList);	//	cpuidをリストビューに出力

void cpuid_summary(TCHAR* str,int sz){
	TCHAR buf[256];
	TCHAR *p = name;
	while (*p == _T(' '))
		++p;
	_stprintf_s(str,sz,_TEXT("%s,"),p);

	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%i,%i,"), coreMax,threadMax);

	_tcscat_s(str,sz,buf);

	DWORD i;
	_tcscpy_s(buf, sizeof(buf) / sizeof(TCHAR),_TEXT(","));
	for (i = 0; i < cache_max; i++){
		if (cache[i].level == 1 && cache[i].type == 2){
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%dkByte*%d個 %dway,"), cache[i].size, threadMax / cache[i].uThread, cache[i].way);
			break;
		}
		if (cache[i].level == 1 && cache[i].type == 4){
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("Trace Cache %dkμOPs %dway*%d個,"), cache[i].size, cache[i].way, coreMax);
			break;
		}
	}
	_tcscat_s(str,sz,buf);

	_tcscpy_s(buf, sizeof(buf) / sizeof(TCHAR),_TEXT(","));
	for (i = 0; i < cache_max; i++){
		if (cache[i].level == 1 && cache[i].type == 1){
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%dkByte*%d個 %dway,"), cache[i].size, threadMax / cache[i].uThread, cache[i].way);
			break;
		}
	}
	_tcscat_s(str,sz,buf);
	_tcscpy_s(buf, sizeof(buf) / sizeof(TCHAR),_TEXT(","));
	for (i = 0; i < cache_max; i++){
		if (cache[i].level == 2 && cache[i].type == 3){
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%dkByte*%d個 %dway,"), cache[i].size, threadMax / cache[i].uThread, cache[i].way);
			break;
		}
	}
	_tcscat_s(str,sz,buf);
	_tcscpy_s(buf, sizeof(buf) / sizeof(TCHAR),_TEXT(","));
	for (i = 0; i < cache_max; i++){
		if (cache[i].level == 3 && cache[i].type == 3){
			_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%dkByte*%d個 %dway,"), cache[i].size, threadMax / cache[i].uThread, cache[i].way);
			break;
		}
	}
	_tcscat_s(str,sz,buf);

	REG32 reg_temp;
	cpuid(0, reg_temp.vec, 1);

	EAX1 eax1;
	eax1.dword = reg_temp.eax;
	EBX1 ebx1;
	ebx1.dword = reg_temp.ebx;
	ECX1 ecx1;
	ecx1.dword = reg_temp.ecx;
	EDX1 edx1;
	edx1.dword = reg_temp.edx;

	int ext_f;
	int ext_m;
	if (eax1.family != 0xf)
		ext_f = eax1.family;
	else
		ext_f = eax1.family + eax1.ex_family;
	if (eax1.family == 6 || eax1.family == 0xf)
		ext_m = (eax1.ex_model << 4) + eax1.model;
	else
		ext_m = eax1.model;
	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%x,%x,%x,%x,%x,"), eax1.family, eax1.model, eax1.stepping,ext_f, ext_m);
	_tcscat_s(str,sz,buf);

	ext_inst_str(buf, sizeof(buf) / sizeof(TCHAR));
	_tcscat_s(str,sz,buf);
}

};


class CPU{
public:
	DWORD lCpuMax;	//	システムの論理CPU数
	void cpuid_cpp_put(void);	//	物理パッケージのCPUIDをC++のクラスとしてソースをファイルに出力
	void cpuid_put(FILE* fpv);	//	取得されたcpuidをファイルに出力
	void cpuid_info_put(FILE* fpv);//	cpuidの実行結果を全部出力
	CPU();	//	エミュレーションしない場合のコンストラクタ
	CPU(int package);	//	エミュレーションする場合のコンストラクタ　物理パッケージ数（ソケット数）を指定
	~CPU();
	TCHAR* getCpuName(void){
		return cpu_pkg[0]->name;
	}
	CPU_PKG** cpu_pkg;	//	物理パッケージ情報	
	DWORD pkgMax;	//	物理パッケージ数
protected:
	DWORD* smt, *core, *pkg;	//	Windowsの論理CPU番号に対するスレッド番号、コア番号、パッケージ番号
	DWORD* temp;
	UINT64 mask;	//	スレッド実行CPUを固定
	UINT64 sysmask;	//	スレッド実行CPUを固定
	int* emu_cpu_num;	//	仮想CPU番号と実CPU番号の対比表
	void make_cpuid_para(int* cpun, int* pkgn, int* threadn){
		UINT64 bit = 1;
		DWORD cpu_num;	//	maskより仮想CPU番号を取得(maskでビットが1である一番若いビット位置のCPUIDを返す
		for (cpu_num = 0; cpu_num < lCpuMax; cpu_num++){
			if (bit & mask){
				break;
			}
			bit = bit << 1;
		}
		int pkgnum = pkg[cpu_num];
		int corenum = core[cpu_num];
		int smtnum = smt[cpu_num];
		int thread_num = 0;
		DWORD n;
		for (n = 0; n < cpu_pkg[pkgnum]->threadMax; n++){
			if (cpu_pkg[pkgnum]->threadvec[n] == cpu_num)
				thread_num = n;
		}
		*pkgn = pkgnum;
		*threadn = thread_num;
		*cpun = cpu_num;
	}
	//	vcpumaxの仮想CPUを現システムの論理CPUに割り当てる

	void alloc_cpu(int* v, int vcpumax){
		SYSTEM_INFO sys;
		::GetSystemInfo(&sys);
		int syscpumax = sys.dwNumberOfProcessors;	//現在のシステムの論理CPU数

		if (vcpumax <= syscpumax / 2){	//	2個飛ばしにCPUを割り当てる
			int u = 0;
			int n;
			for (n = 0; n < vcpumax; n++){
				v[n] = u  % syscpumax;
				u += 2;
			}
		}
		else{	//	現在のシステムの論理CPU数 <=　仮想CPUの論理CPU数
			int n;
			for (n = 0; n < vcpumax; n++){
				v[n] = n % syscpumax;
			}
		}
	}
	union CMP_TEMP{
		struct {
			char num;
			char smt;
			char core;
			char pkg;
		};
		int dword;
	};
	friend int dwordcmp(const void *dtcp, const void* srcp); public:

	void init(void);	//	エミュレーション時にCPUトポロジーよりパッケージ・コア・スレッドを取得
	//	現システムからCPUID実行結果を抽出する。
	void getCPUID(void);
	int bit_num(UINT64 bit);	//	1のビット数を取得する
	DWORD_PTR emuSetThreadAffinityMask(HANDLE h, UINT64 vmask);	//	実行CPUを固定
	BOOL emuGetProcessAffinityMask(HANDLE h, UINT64* vmask, UINT64* vsysmask);	//	実行中のCPUを取得
	void emuGetSystemInfo(SYSTEM_INFO* sys);
	void cpuid(int* info, int eax);	//	取得されたcpuidによりエミュレーション
	void cpuidex(int* info, int eax, int ecx);	//	取得されたcpuidによりエミュレーション
	void get(void);	//	現システムの解析
	void parse(void);	//	init()の結果より
	void add(int package, CPU_PKG* cpu);
	void Draw(HDC hdc, int sx, int sy);
	int getPackageMax(void);	//	物理パッケージ数(ソケット)を取得
};

typedef CPU_PKG* CPU_PKG_P;

#endif
